function Initialise()

  -- Sets up mines and turn time
   SetData("Mine.DudProbabilty", 0.1)
   SetData("Mine.MinFuse", 1000)
   SetData("Mine.MaxFuse", 5000)
   SendMessage("GameLogic.PlaceObjects")

   SetupWormsAndTeams()
   SetupInventories()

   SetData("HotSeatTime", 0) -- no hotseat time
   SetData("RoundTime", 0) -- no Game timer
   SetData("TurnTime", 0) -- no game timer

   StartFirstTurn()

end


-- This replaces the function in stdlib
function TurnEnded()
   SendMessage("WormManager.GetActiveWormCount")
   WormCount = GetData("WormCount")
   if WormCount == 0 then
      -- all the worms have just snuffed it
      SendMessage("GameLogic.EndGame")
   else
      -- still at least some worms left
      StartTurn()
   end
end


function SetupWormsAndTeams()

   -- Activate Team 0
   lock, team = EditContainer("Team.Data00") 
   team.Active = true
   team.Name = "Allies"
   team.TeamColour = 0
   CloseContainer(lock) -- must close the container ASAP

   -- Worm 0, Team 0
   lock, worm = EditContainer("Worm.Data00") 
   worm.Active = true
   worm.Name = "Riley"
   worm.Energy = 100
   worm.WeaponFuse = 3
   worm.WeaponIsBounceMax = false
   worm.TeamIndex = 0
   CloseContainer(lock) 

   -- Worm 1, Team 0
   CopyContainer("Worm.Data00", "Worm.Data01")
   lock, worm = EditContainer("Worm.Data01") 
   worm.Name = "Sarge"
   CloseContainer(lock)

   -- Worm 2, Team 0
   CopyContainer("Worm.Data00", "Worm.Data02")
   lock, worm = EditContainer("Worm.Data02") 
   worm.Name = "Ryan"
   CloseContainer(lock)

   -- Worm 3, Team 0
   CopyContainer("Worm.Data00", "Worm.Data03")
   lock, worm = EditContainer("Worm.Data03") 
   worm.Name = "Frost"
   CloseContainer(lock)

   SendMessage("WormManager.Reinitialise")

end



function SetupInventories()
   -- sets up the inventory container and adds our selection to it
   lock, inventory = EditContainer("Inventory.Team00") 
   inventory.Bazooka = -1
   inventory.Grenade = -1
   inventory.ClusterGrenade = -1
   inventory.Airstrike = -1
   inventory.Dynamite = -1
   inventory.HolyHandGrenade = -1
   inventory.BananaBomb = -1
   inventory.Landmine = -1
   inventory.Shotgun = -1
   inventory.Uzi = -1
   inventory.Minigun = -1
   inventory.Prod = -1
   inventory.FirePunch = -1
   inventory.HomingMissile = -1
   inventory.HomingPidgeon = -1
   inventory.Sheep = -1
   inventory.Parachute = -1
   --inventory.Lasergun = -1
   inventory.Teleport = -1
   inventory.NinjaRope = -1
   inventory.Jetpack = -1
   inventory.BaseballBat = -1
   CloseContainer(lock) -- must close the container ASAP

end

