
function Initialise()
--SendStringMessage("Camera.Disable", "Track")
    SendMessage("Commentary.NoDefault")
    SetData("Crate.TrackCam", 0)
    
    NewCrate = 1
    camdone = 0    
    CrateNumber = 0
    KEndGame = 0
    
    SendMessage("EFMV.Start") 
    SendMessage("HUD.HideTurnTime")
    SetData("Camera.StartOfTurnCamera","Default")
    SetData("Camera.GameOverCamera", "")
  
-- Sets up mines and turn time
   SetData("Mine.DudProbabilty", 0.1)
   SetData("Mine.MinFuse", 3000)
   SetData("Mine.MaxFuse", 4000)
   SetData("HotSeatTime", 0) -- no hotseat time
--fancy pants way of starting round time for use with timed warnings
    RoundTimeRemaining = 0
    SetData("Jetpack.InitFuel", 20000)
    SetData("Jetpack.MaxAltitude", 5500)
    SetData("RoundTime", RoundTimeRemaining) 
    warn = StartTimer("warning", RoundTimeRemaining -10000)
   
    SetData("RoundTime", 60000)
      
    SetData("TurnTime", 0)
   
    SendMessage("GameLogic.PlaceObjects")

    SetupWormsAndTeams()
    SetupInventories()
   -- StartFirstTurn()
    camera()
    MakeNewCrate()
end

---dontendturn
function TurnStarted()
    SelectRandomWind()
end

function Weapon_Fired_Start()
end

function Weapon_Fired_End()
   SendMessage("Weapon.Delete")
   SendMessage("Weapon.Create")
end

function Weapon_PoweringUpStart()
end

function StartFirstTurn()
    WaitUntilNoActivity = false
    SendMessage("Timer.StartGame")
    SendMessage("EFMV.End")
  
    StartTurn()
end

function TurnEnded()
    if KEndGame == 0 then
        KEndGame = 1
        endmissionfail()
    end
end

function Timer_GameTimedOut()
    SetData("CommentaryPanel.Comment", "Chall.Generic.Win3")
    SendMessage("CommentaryPanel.ScriptText")
    if KEndGame == 0 then
        KEndGame = 1
        endmissionfail()
    end
end

function CheckOneTeamVictory()
end
---dontendturn

function Worm_Died()
    deadworm = GetData("DeadWorm.Id")
    if deadworm == 0 then
        SetData("CommentaryPanel.Comment", "Chall.Generic.Lose1")
        SendMessage("CommentaryPanel.ScriptText")
    end
end

function endmissionfail()
    SetData("CommentaryPanel.Comment", "Chall.Generic.Win1")
    SendMessage("CommentaryPanel.ScriptText")

    SetData("MCa.LastGameTime", GetData("ElapsedRoundTime"))
     timetook = GetData("ElapsedRoundTime")
     goldtime = GetData("MCa.BestGold")
     silvertime = GetData("MCa.BestSilver")
     bronzetime = GetData("MCa.BestBronze")
     if timetook > goldtime then
            SetData("GameOver.AwardMovie","gold")
        elseif timetook > silvertime then
            SetData("GameOver.AwardMovie","silver")
        elseif timetook > bronzetime then
            SetData("GameOver.AwardMovie","bronze")
        end
     SendMessage("GameLogic.Challenge.Result")
end

--checks if time is low
function timelow()
    CancelTimer(warn)
    RoundTimeRemaining = GetData("RoundTimeRemaining")
    warn = StartTimer("warning", RoundTimeRemaining -10000)
end

function warning()
end

function SetupWormsAndTeams()
   GM = QueryContainer("GM.GameInitData")
   -- Activate Team 0
   lock, team = EditContainer("Team.Data00") 
   team.Active = true
    team.Name = GM.T1_Name
    team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave
   team.TeamColour = 0
   CloseContainer(lock) -- must close the container ASAP

   -- Worm 0, Team 0
   lock, worm = EditContainer("Worm.Data00") 
   worm.Active = true
    worm.Name = GM.T1_W1_Name
    worm.SfxBankName = GM.T1_Speech
   worm.Energy = 1
   worm.Spawn = "wspawn1"
   worm.WeaponFuse = 3
   worm.WeaponIsBounceMax = false
   worm.IsEmotional = false
   worm.TeamIndex = 0
   CloseContainer(lock) 
 
   SendMessage("WormManager.Reinitialise")
end

function SetupInventories()
    lock, inventory = EditContainer("Inventory.Team.Default") 
    inventory.Parachute = -1
    CloseContainer(lock) -- must close the container ASAP

    CopyContainer("Inventory.Team.Default", "Inventory.Team00")
end


function SelectRandomWind()
   -- First the speed
   SendMessage("RandomNumber.Get")
   RandomNumber = GetData("RandomNumber.Float")
   MaxWind = GetData("Wind.MaxSpeed")
   SetData("Wind.Speed", 0.1*MaxWind)

   -- Now a direction
   SendMessage("RandomNumber.Get")
   RandomNumber = GetData("RandomNumber.Float")
   Direction = RandomNumber * 2 * 3.14
   SetData("Wind.Direction", 0.1) 
end

function Crate_Collected()
    CrateNumber = GetData("Crate.Index")
    SetData("CommentaryPanel.Comment", "missrum.game5")
    SendMessage("CommentaryPanel.ScriptText") 
     
    if CrateNumber == 7 then
        SetData("CommentaryPanel.Comment", "Chall.Chute1.game1")
        SendMessage("CommentaryPanel.ScriptText")
    end
    
   
    MakeNewCrate()
end

function Crate_Destroyed()
 --   MakeNewCrate()
end

-- When MakeNewCrate is called It runs through this below and adds 1 each time so it knows which crate it is on

function MakeNewCrate()

    if NewCrate == 1 then
    
	SetData("Crate.Spawn", "crate1")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 1)
        SetData("Crate.Scale", 5)
        SetData("Crate.Pushable", 0)    
        SetData("Crate.FallSpeed", 0)
        SetData("Crate.Parachute", 0)
        SetData("Crate.Gravity", 0)
        SetData("Crate.WaitTillLanded", 0) 
	SendMessage("GameLogic.CreateCrate")
        RoundTimeRemaining = GetData("RoundTimeRemaining")
        SetData("RoundTimeRemaining", RoundTimeRemaining+20000)
        timelow()
 
     elseif NewCrate == 2 then
	SetData("Crate.Spawn", "crate2")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 2)
        SetData("Crate.Scale", 5)
	SetData("Crate.FallSpeed", 0)
	SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        RoundTimeRemaining = GetData("RoundTimeRemaining")
        SetData("RoundTimeRemaining", RoundTimeRemaining+15000)
        timelow()


     elseif NewCrate == 3 then
	SetData("Crate.Spawn", "crate3")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 3)
        SetData("Crate.Scale", 5)
	SetData("Crate.FallSpeed", 0)
	SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        RoundTimeRemaining = GetData("RoundTimeRemaining")
        SetData("RoundTimeRemaining", RoundTimeRemaining+12000)
        timelow()
        
     elseif NewCrate == 4 then
	SetData("Crate.Spawn", "crate4")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 4)
        SetData("Crate.Scale", 5)
	SetData("Crate.FallSpeed", 0)
	SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        RoundTimeRemaining = GetData("RoundTimeRemaining")
        SetData("RoundTimeRemaining", RoundTimeRemaining+7000)
        timelow()
        
     elseif NewCrate == 5 then
	SetData("Crate.Spawn", "crate5")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 5)
         SetData("Crate.Scale", 5)
	 SetData("Crate.FallSpeed", 0)
	SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        RoundTimeRemaining = GetData("RoundTimeRemaining")
        SetData("RoundTimeRemaining", RoundTimeRemaining+6000)
        timelow()
    
    elseif NewCrate == 6 then
	SetData("Crate.Spawn", "crate6")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 6)
         SetData("Crate.Scale", 5)
	 SetData("Crate.FallSpeed", 0)
	SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        RoundTimeRemaining = GetData("RoundTimeRemaining")
        SetData("RoundTimeRemaining", RoundTimeRemaining+6000)
        timelow()
   
     elseif NewCrate == 7 then
	SetData("Crate.Spawn", "crate7")
        SetData("Crate.Type", "Utility")
	SetData("Crate.Index", 7)
         SetData("Crate.Scale", 2)
	 SetData("Crate.NumContents", 1)
	SetData("Crate.Contents", "kUtilityJetpack")
	SendMessage("GameLogic.CreateCrate")
        RoundTimeRemaining = GetData("RoundTimeRemaining")
        SetData("RoundTimeRemaining", RoundTimeRemaining+20000)
        timelow()

     elseif NewCrate == 8 then
        SetData("Crate.Spawn", "crate8")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 8)
	SetData("Crate.Scale", 5)
	SetData("Crate.FallSpeed", 0)
	SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        RoundTimeRemaining = GetData("RoundTimeRemaining")
        SetData("RoundTimeRemaining", RoundTimeRemaining+5000)
        timelow()
      

     elseif NewCrate == 9 then
	SetData("Crate.Spawn", "crate9")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 9)
         SetData("Crate.Scale", 5)
	 SetData("Crate.FallSpeed", 0)
	SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        RoundTimeRemaining = GetData("RoundTimeRemaining")
        SetData("RoundTimeRemaining", RoundTimeRemaining+5000)
        timelow()
      
     elseif NewCrate == 10 then
	SetData("Crate.Spawn", "crate10")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 10)
         SetData("Crate.Scale", 5)
	 SetData("Crate.FallSpeed", 0)
	SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        RoundTimeRemaining = GetData("RoundTimeRemaining")
        SetData("RoundTimeRemaining", RoundTimeRemaining+4000)
        timelow()
     
      elseif NewCrate == 11 then
	SetData("Crate.Spawn", "crate11")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 11)
         SetData("Crate.Scale", 5)
	 SetData("Crate.FallSpeed", 0)
	SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        RoundTimeRemaining = GetData("RoundTimeRemaining")
        SetData("RoundTimeRemaining", RoundTimeRemaining+4000)
	
	 elseif NewCrate == 12 then
	SetData("Crate.Spawn", "crate12")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 12)
         SetData("Crate.Scale", 5)
	 SetData("Crate.FallSpeed", 0)
	SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        RoundTimeRemaining = GetData("RoundTimeRemaining")
        SetData("RoundTimeRemaining", RoundTimeRemaining+4000)
	
	 elseif NewCrate == 13 then
	SetData("Crate.Spawn", "crate13")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 13)
         SetData("Crate.Scale", 5)
	 SetData("Crate.FallSpeed", 0)
	SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        RoundTimeRemaining = GetData("RoundTimeRemaining")
        SetData("RoundTimeRemaining", RoundTimeRemaining+4000)
	
	 elseif NewCrate == 14 then
	SetData("Crate.Spawn", "crate14")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 14)
         SetData("Crate.Scale", 5)
	 SetData("Crate.FallSpeed", 0)
	SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        RoundTimeRemaining = GetData("RoundTimeRemaining")
        SetData("RoundTimeRemaining", RoundTimeRemaining+4000)
	
        elseif NewCrate == 15 then
	SetData("Crate.Spawn", "crate15")
        SetData("Crate.Type", "Utility")
	SetData("Crate.Index", 15)
         SetData("Crate.Scale", 2)
	SetData("Crate.NumContents", 1)
	SetData("Crate.Contents", "kUtilityJetpack")
	 SetData("Crate.FallSpeed", 0)
	SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        RoundTimeRemaining = GetData("RoundTimeRemaining")
        SetData("RoundTimeRemaining", RoundTimeRemaining+1600)
	
	 elseif NewCrate == 16 then
	SetData("Crate.Spawn", "crate16")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 16)
         SetData("Crate.Scale", 5)
	 SetData("Crate.FallSpeed", 0)
	SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        RoundTimeRemaining = GetData("RoundTimeRemaining")
        SetData("RoundTimeRemaining", RoundTimeRemaining+15000)
	
	 elseif NewCrate == 17 then
	SetData("Crate.Spawn", "crate17")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 17)
         SetData("Crate.Scale", 5)
	 SetData("Crate.FallSpeed", 0)
	SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        RoundTimeRemaining = GetData("RoundTimeRemaining")
        SetData("RoundTimeRemaining", RoundTimeRemaining+10000)
	
	 elseif NewCrate == 18 then
	SetData("Crate.Spawn", "crate18")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 18)
         SetData("Crate.Scale", 5)
	 SetData("Crate.FallSpeed", 0)
	SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        RoundTimeRemaining = GetData("RoundTimeRemaining")
        SetData("RoundTimeRemaining", RoundTimeRemaining+8000)
	
	 elseif NewCrate == 19 then
	SetData("Crate.Spawn", "crate19")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 19)
         SetData("Crate.Scale", 5)
	 SetData("Crate.FallSpeed", 0)
	SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        RoundTimeRemaining = GetData("RoundTimeRemaining")
        SetData("RoundTimeRemaining", RoundTimeRemaining+7000)
	
	 elseif NewCrate == 20 then
	SetData("Crate.Spawn", "crate20")
        SetData("Crate.Type", "Target")
	SetData("Crate.Index", 20)
         SetData("Crate.Scale", 5)
	 SetData("Crate.FallSpeed", 0)
	SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        RoundTimeRemaining = GetData("RoundTimeRemaining")
        SetData("RoundTimeRemaining", RoundTimeRemaining+5000)

	
	 elseif NewCrate == 21 then
	SetData("Crate.Spawn", "crate16")
        SetData("Crate.Type", "Utility")
	SetData("Crate.Index", 21)
         SetData("Crate.Scale", 2)
	SetData("Crate.NumContents", 1)
	SetData("Crate.Contents", "kUtilityJetpack")
	 SetData("Crate.FallSpeed", 0)
	SetData("Crate.Gravity", 0)
	SendMessage("GameLogic.CreateCrate")
        RoundTimeRemaining = GetData("RoundTimeRemaining")
        SetData("RoundTimeRemaining", RoundTimeRemaining+13000)

	-- THIS IS WHERE IT SHOULD REPEAT
	
        NewCrate = 0

     end
         NewCrate = NewCrate + 1
end

function camera()
    SetData("CommentaryPanel.Comment", "Chall.Chute2.Intro1")
    SetData("CommentaryPanel.Delay",3000)
    SendMessage("CommentaryPanel.TimedText")
    SetData("Camera.Path.Knots.Position", "Pos1,Pos2,Pos3,Pos4,Pos5,Pos6,Pos7,Pos8")
    SetData("Camera.Path.Knots.LookAt", "Look1")
    SetData("Camera.Path.Loop.LookAt", 0) 
    SetData("Camera.Path.Tension.Position", -0.2)
    SetData("Camera.Path.Steps.Position",150)  
    SetData("Camera.Path.Steps.LookAt",850)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("camera2", 5000)
end


function camera2()
    SetData("CommentaryPanel.Comment", "Chall.Chute2.Intro2")
SetData("CommentaryPanel.Delay",3000)
SendMessage("CommentaryPanel.TimedText")
  
 SetData("CommentaryPanel.Comment", "Chall.Chute1.Intro3")
SetData("CommentaryPanel.Delay",3000)
SendMessage("CommentaryPanel.TimedText")
    SendIntMessage("Worm.ResetAnim", 0)
    SetData("Worm.ScriptAnim", "Smile")
    SendIntMessage("Worm.QueueAnim", 0)
    SetData("Camera.Path.Knots.Position", "Pos9")
    SetData("Camera.Path.Knots.LookAt", "Look2")
    SetData("Camera.Path.Loop.LookAt", 0) 
    SetData("Camera.Path.Tension.Position", -0.2)
    SetData("Camera.Path.Steps.Position",650)  
    SetData("Camera.Path.Steps.LookAt",850)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("StartFirstTurn", 2500)
end

function Camera_Path_Stopped()
    if camdone == 0 then
            camdone =  1
	     CancelTimer(CamLoop)
        StartFirstTurn()

        SendMessage("EFMV.End") 
    end
end