---------------------------------------------------------
-- Simple script to show how to turn particle emitters on & off
-- A Detail Object should have been placed in the editor at the postion 
-- where the emitter is required
--
-- This does the following
--
-- 1) Waits 10 seconds and then call Particle_StartEvent
-- 2) Sets the name of the detail object to attact the emitter to in game data
-- 3) Sets the desired emitter effect in game data
-- 4) Sends NewEmtter message to create the emitter (storing the return handle)
-- 5) Gets the handle of the particle emitter created. Each emitter created 
--    has a unique handle reference which should be shored for later 
--    reference - eg when you want to kill the emitter
-- 6) Waits 30 seconds & then calls Particle_EndEvent 
-- 7) Sends a message to the game to destroy the emitter, passing the handle
--    that was returned when the emitter was created
---------------------------------------------------------

---------------------------------------------------------
function Initialise()

	TimerID = StartTimer("Particle.StartEvent", 10000)
	
	StartFirstTurn()	
end

---------------------------------------------------------
-- This function creates the particle emitter
---------------------------------------------------------
function Particle_StartEvent()	

	SetData("Particle.DetailObject", "ParticleFire")
	SetData("Particle.Name","ParticleFire")

	SendMessage("Particle.NewEmitter")
	id = GetData("Particle.Handle")
	
	TimerID = StartTimer("Particle.EndEvent", 30000)
end

---------------------------------------------------------
-- This function destroys the particle emitter
---------------------------------------------------------
function Particle_EndEvent()

	SendIntMessage("Particle.DeleteEmitter",id)
end

