
-- Mission - Showdown At The OK-Coral Reef

--The player has two tasks to perform in order to complete this mission..
--One is to take out all the enemy worms, the other is to collect the vital crate.
--These can be done in any order, but both are required to be awarded the win.

--I plan to add a secret into this mission, it'll probably be a star located on top of an
--un-reachable building - forcing the player into blasting it down.

function Initialise()
    bronzetime = (60 * 1000) * 999
    silvertime = (60 * 1000) * 5
    goldtime = (60 * 1000) * 4.5
    SetData("Mine.DudProbabilty", 0.3)
    SetData("Mine.MinFuse", 2000)
    SetData("Mine.MaxFuse", 4000)

    SendMessage("EFMV.Start")
    
    SetData("TurnTime", 25000)
    SetData("HotSeatTime", 5000)
    SetData("RoundTime", 900000)
    
    SetData("Camera.StartOfTurnCamera","Default")
   
    SetData("Particle.DetailObject", "Bell")
    SetData("Particle.Name", "Part_Bell")
    SendMessage("Particle.NewEmitter")
    
    SendMessage("GameLogic.PlaceObjects")
    SendMessage("GameLogic.ChangeWind")

    Collected = 0
    Anim1Time = StartTimer("Bree", 5000)
    Anim1Run = 1
    Anim2Time = StartTimer("Bree2", 17000)
    Anim2Run = 1
    Anim3Time = StartTimer("Movee", 9000)
    Anim3Run = 1
    Anim4Time = StartTimer("Moveee", 20000)
    Anim4Run = 1
    
    Switch = 0
    Switch2 = 0
    CollectCamRunning = 0
    CPUGone = 0
    
    SetData("Particle.DetailObject", "CrateSpawn1")
    SetData("Particle.Name", "Part_StarBridge")
    SendMessage("Particle.NewEmitter")
    KCrateSparkle = GetData("Particle.Handle")
    
    SetupWormsAndTeams()
    SetupInventories()
    Cratespawn()
    Camera()
end

function StartFirstTurn()
    WaitUntilNoActivity = false
    SendMessage("Timer.StartGame")
    SendMessage("EFMV.End")
    StartTurn()
end

function TurnEnded()
    if CollectCamRunning == 0 then
       CheckOneTeamVictory()
       RoundTimeCheck()

    elseif CollectCamRunning == 1 then
        StartTimer("CheckOneTeamVictory", 3000)
        StartTimer("RoundTimeCheck", 3000)
    end
end

function RoundTimeCheck()

    RoundTimeRemaining = GetData("RoundTimeRemaining")
    if RoundTimeRemaining == 0 or RoundTimeRemaining < 0 then
        if Switch == 0 then
            FailureMessages()
            --This needs to be a failure message
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
    end
        
end


function Bree()
    Anim1Run = 0
    SendIntMessage("Worm.ResetAnim", 3)
    SetData("Worm.ScriptAnim", "Taunt1")
    SendIntMessage("Worm.QueueAnim", 3)
end

function Bree2()
    Anim2Run = 0
    SendIntMessage("Worm.ResetAnim", 6)
    SetData("Worm.ScriptAnim", "NotMe6")
    SendIntMessage("Worm.QueueAnim", 6)
end

function Movee()
    Anim3Run = 0
    SendIntMessage("Worm.ResetAnim", 5)
    SetData("Worm.ScriptAnim", "Wave_Right")
    SendIntMessage("Worm.QueueAnim", 5)
end

function Moveee()
    Anim4Run = 0
    SendIntMessage("Worm.ResetAnim", 7)
    SetData("Worm.ScriptAnim", "Bored1")
    SendIntMessage("Worm.QueueAnim", 7)
end

function Camera()
    CameraFly = 1
    SetData("CommentaryPanel.Comment", "Miss.Showdown.Here")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("CommentaryPanel.Comment", "Miss.Showdown.Here2")
    SendMessage("CommentaryPanel.ScriptText")
    
    SetData("Camera.Path.Knots.Position", "Pos1,Pos2,Pos3,Pos4,Pos5,Pos6")
    SetData("Camera.Path.Knots.LookAt", "Look1,Look2,Look3,Look4,Look5")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",500)  
    SetData("Camera.Path.Steps.LookAt",550)
    SetData("Camera.Path.Tension.Position", 0) 
    SendMessage("Camera.Path.Start")
    
    TextTimer = StartTimer("ExtraTexte", 10000)
    Text1Run = 1
    TextTimer2 = StartTimer("ExtraTextee", 20000)
    Text2Run = 1
    CamLoop = StartTimer("GOGO", 25000)
end

function ExtraTexte()
    Text1Run = 0
    SetData("CommentaryPanel.Comment", "Miss.Showdown.Here3")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("CommentaryPanel.Comment", "Miss.Showdown.Here4")
    SendMessage("CommentaryPanel.ScriptText")
end

function ExtraTextee()
    Text2Run = 0
    SetData("CommentaryPanel.Comment", "Miss.Showdown.Guard")
    SendMessage("CommentaryPanel.ScriptText")
end

function GOGO()
    SetData("Camera.Path.Knots.Position", "PosA,PosB")
    SetData("Camera.Path.Knots.LookAt", "LookA")
    SetData("Camera.Path.Loop.LookAt", 0)
    SetData("Camera.Path.Steps.Position",75)  
    SetData("Camera.Path.Steps.LookAt",75)
    SetData("Camera.Path.Tension.Position", 0) 
    SendMessage("Camera.Path.Start")

    SendIntMessage("Worm.ResetAnim", 1)
    SetData("Worm.ScriptAnim", "Angry")
    SendIntMessage("Worm.QueueAnim", 1)
    
    CamLoop = StartTimer("GOGO2", 2500)
end

function GOGO2()
    CameraFly = 0
    StartFirstTurn()
    SetData("CommentaryPanel.Comment", "Miss.Showdown.Start")
    SendMessage("CommentaryPanel.ScriptText")
end

function Camera_Path_Stopped()
    if CameraFly == 1 then
        if Anim1Run == 1 then
            CancelTimer(Anim1Time)
        end
        
        if Anim2Run == 1 then
            CancelTimer(Anim2Time)
        end
        
        if Anim3Run == 1 then
            CancelTimer(Anim3Time)
        end
        
        if Anim4Run == 1 then
            CancelTimer(Anim4Time)
        end
    
        if Text1Run == 1 then
            CancelTimer(TextTimer)
        end
        
        if Text2Run == 1 then
            CancelTimer(TextTimer2)
        end
        SendMessage("Commentary.Clear")
        CameraFly = 0
        CancelTimer(CamLoop)
        StartFirstTurn()
    end
end


function FailureMessages()
    SendMessage("Commentary.Clear")
    
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 5) + 1
   
    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose2")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose3")
        SendMessage("CommentaryPanel.ScriptText") 
    elseif MyRandomNumber == 4 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 5 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose5")
        SendMessage("CommentaryPanel.ScriptText")        
    end
end

function Crate_Destroyed()
    CrateNumber = GetData("Crate.Index")
    if CrateNumber == 1 then
        SendIntMessage("Particle.DeleteEmitter", KCrateSparkle)--bm1
        SendMessage("Commentary.NoDefault")
        SendMessage("Commentary.Clear")
        SetData("CommentaryPanel.Comment", "Miss.Showdown.Failed")
        SendMessage("CommentaryPanel.ScriptText")
        SetData("CommentaryPanel.Comment", "Miss.generic.fail")
        SendMessage("CommentaryPanel.ScriptText")
        GameEnd()
    end
end



function Crate_Collected()
    CrateNumber = GetData("Crate.Index")
    if CrateNumber == 1 then
        Collected = 1
        SendIntMessage("Particle.DeleteEmitter", KCrateSparkle)--bm1
        if CPUGone == 0 then
            PauseGame()
            CollectCamRunning = 1
            CrateCollectCam()
        elseif CPUGone == 1 then
            CheckOneTeamVictory()
        end
    elseif CrateNumber == 2 then
        SendMessage("Commentary.Clear")
        SetData("CommentaryPanel.Comment", "Miss.Showdown.EasterEgg")
        SendMessage("CommentaryPanel.ScriptText")
        SetData("CommentaryPanel.Comment", "Miss.NotPC.egg8")
        SendMessage("CommentaryPanel.ScriptText")
       
        Key,Lock = EditContainer("L.P.Giraffe")
        if Lock.Locked == true then
            Lock.Locked = false
            SetData("MCa.LockedName3","L.P.Giraffe")
        end
        CloseContainer(Key)
    end
end

function PauseGame()
    SendMessage("EFMV.Start")
    SendMessage("GameLogic.RoundTime.Pause")
    SendMessage("GameLogic.TurnTime.Pause")
    SendMessage("GameLogic.PauseGame")
    SendStringMessage("Camera.Disable", "Track")
    SetData("GameLogic.ArtilleryMode", 1)
end

function CrateCollectCam()
    SendMessage("Commentary.Clear")
    SetData("CommentaryPanel.Comment", "Miss.Showdown.CrateCollected")
    SendMessage("CommentaryPanel.ScriptText")

    SetData("Camera.Path.Knots.Position", "KCollectCam,KCollectCam2")
    SetData("Camera.Path.Knots.LookAt", "KCollectLook")
    SetData("Camera.Path.Steps.Position",600)  
    SetData("Camera.Path.Steps.LookAt",0)
    SetData("Camera.Path.IgnoreInput", 1)
    SendMessage("Camera.Path.Start")

    

    StartTimer("ResumeGame", 3000)
end

function ResumeGame()
    CollectCamRunning = 0
    SendMessage("EFMV.End")
    SendMessage("GameLogic.RoundTime.Resume")
    SendMessage("GameLogic.TurnTime.Resume")
    SendMessage("GameLogic.ResumeGame")
    SendStringMessage("Camera.Enable", "Track")
    SetData("GameLogic.ArtilleryMode", 0)
    SendMessage("Camera.SetDefault")
end

function GameEnd()
    SendMessage("GameLogic.Mission.Failure")
end


--This function checks that both the conditions have been met before awarding the win.
function CheckOneTeamVictory()

    TeamCount = GetData("TeamCount")
    -- PC: use SurvivingTeamIndex to get the last team with any worms alive on.
    WhichTeam = GetData("SurvivingTeamIndex")
    
    if TeamCount == 0 then
        if Switch == 0 then
            Switch = 1
            SendMessage("Commentary.Clear")
            FailureMessages()
            -- all the teams have just snuffed it - mission is over:
            SendMessage("GameLogic.Mission.Failure")
            --This section fails the player is only the AI team is left alive:
        end
    elseif TeamCount == 1 and WhichTeam == 1 then
        if Switch == 0 then
            Switch = 1
            SendMessage("Commentary.Clear")
            SetData("CommentaryPanel.Comment", "Miss.Showdown.FailureNEW")
            SendMessage("CommentaryPanel.ScriptText")
            SendMessage("GameLogic.Mission.Failure")
        end
        --THIS IS THE VICTORY, SINCE THE USER HAS BOTH DEFEATED THE ENEMY AND COLLECTED THE CRATE
    elseif TeamCount == 1 and WhichTeam == 0 and Collected == 1 then
        Switch = 1
        SendMessage("Commentary.Clear")
        SetData("CommentaryPanel.Comment", "Miss.Showdown.Success")
        SendMessage("CommentaryPanel.ScriptText")
        --The YES fucntion is just the Success message.
        YES()
        
    elseif TeamCount == 1 and WhichTeam == 0 and Collected == 0 then
        --THIS IS THE USER ONLY TAKING OUT THE ENEMY BUT NOT COLLECTING THE CRATE - 
        --HENCE THE GAME MUST GO ON
        CPUGone = 1
        StartTurn()
   else
        -- still at least 2 teams left so play needs to continue.
        StartTurn()
   end
end

function YES()

    Result()

end


--///////////////////////////////////////////////////////////////
--//            Check for which award you get                  //
--///////////////////////////////////////////////////////////////


function Result()


    SetData("Camera.Path.IgnoreInput", 1)
    
    timetook = GetData("ElapsedRoundTime")
    
    if timetook < bronzetime then
        Movie = 1 
        if timetook < silvertime then
            Movie = 2
            Key,Lock = EditContainer("L.P.LandD")
            if Lock.Locked == true then
                Lock.Locked = false
                SetData("MCa.LockedName2","L.P.LandD")
            end
            CloseContainer(Key)
            if timetook < goldtime then
                Movie = 3
                Key,Lock = EditContainer("L.L.Showdown")
                if Lock.Locked == true then
                    Lock.Locked = false
                    SetData("MCa.LockedName","L.L.Showdown")
                end
                CloseContainer(Key)
            end
        end
    end
    
    
    if Movie == 1 then
        SetData("MCa.LastGameTime", 1)
        SetData("GameOver.AwardMovie","bronze")
    elseif Movie == 2 then
        SetData("MCa.LastGameTime", 2)
        SetData("GameOver.AwardMovie","silver")
    elseif Movie == 3 then
        SetData("MCa.LastGameTime", 3)
        SetData("GameOver.AwardMovie","gold")
    end
    
    SendMessage("GameLogic.Mission.Success")

end

--/////////////////////////////////////////////////////////
--// pick from a bunch of message at the end of the game //
--/////////////////////////////////////////////////////////


function FailureMessages()

    SendMessage("Commentary.Clear")
    SendMessage("Commentary.NoDefault")
    
    -- makes up a random number between 1 and 5
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 5) + 1
   
    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose2")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose3")
        SendMessage("CommentaryPanel.ScriptText") 
    elseif MyRandomNumber == 4 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 5 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose5")
        SendMessage("CommentaryPanel.ScriptText")        
    end
    
end



function Cratespawn()
--This is the mission vital crate, it has been set so only the human player can collect it.
    SetData("Crate.Spawn", "CrateSpawn1")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kWeaponConcreteDonkey")
    SetData("Crate.TeamCollectable", 0)
    SetData("Crate.Index", 1)
    SetData("Crate.GroundSnap", 1)
    SendMessage("GameLogic.CreateCrate")

    SetData("Crate.Spawn", "Special")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kWeaponSuperSheep")
    SetData("Crate.TeamCollectable", 0)
    SetData("Crate.TeamDestructible", 10)
    SetData("Crate.Pushable", 0)
    SetData("Crate.Index", 2)
    SetData("Crate.GroundSnap", 1)
    SendMessage("GameLogic.CreateCrate")
    SendIntMessage("Crate.RadarHide", 2)
end
  
function SetupWormsAndTeams()
    GM = QueryContainer("GM.GameInitData")
    lock, team = EditContainer("Team.Data00") 
    team.Active = true
    team.Name = GM.T1_Name
    team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave
    --team.SfxBankName = GM.T1_Speech
    team.TeamColour = 0
    CloseContainer(lock) 

   -- Activate Team 0
    lock, team = EditContainer("Team.Data01") 
    team.Active = true
    team.Name = "The Pirates!"
    team.FlagGfxName = "94"
    team.IsAIControlled = true
    team.TeamColour = 1
    CloseContainer(lock)

   -- Worm 0, Team 1
    lock, worm = EditContainer("Worm.Data00") 
    worm.Active = true
    worm.Name = GM.T1_W1_Name
    worm.SfxBankName = GM.T1_Speech
    team.GraveIndex = GM.T1_Grave
    worm.Spawn = "spawn1"
    worm.Energy = 100
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    CloseContainer(lock) 

   -- Worm 1, Team 1
    CopyContainer("Worm.Data00", "Worm.Data01")
    lock, worm = EditContainer("Worm.Data01") 
    worm.Name = GM.T1_W2_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "spawn2"
    CloseContainer(lock)

   -- Worm 2, Team 1
    CopyContainer("Worm.Data00", "Worm.Data02")
    lock, worm = EditContainer("Worm.Data02") 
    worm.Name = GM.T1_W3_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "spawn3"
    CloseContainer(lock)

   -- Worm 3, Team 0
    lock, worm = EditContainer("Worm.Data03") 
    worm.Active = true
    worm.Name = "Cap'n Wriggly"
    worm.Spawn = "spawn4"
    worm.Energy = 90
    worm.SfxBankName = "Pirate"
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 1
    CloseContainer(lock) 

   -- Worm 4, Team 0
    CopyContainer("Worm.Data03", "Worm.Data04")
    lock, worm = EditContainer("Worm.Data04")
    worm.Energy = 75
    worm.SfxBankName = "Pirate"
    worm.Name = "Pinkbeard"
    worm.Spawn = "spawn5"
    worm.TeamIndex = 1
    CloseContainer(lock)

   -- Worm 5, Team 0
    CopyContainer("Worm.Data04", "Worm.Data05")
    lock, worm = EditContainer("Worm.Data05")
    worm.Energy = 75  
    worm.SfxBankName = "Pirate"
    worm.Name = "Shipmate Danny"
    worm.Spawn = "spawn6"
    CloseContainer(lock)

   -- Worm 6, Team 0
    CopyContainer("Worm.Data04", "Worm.Data06")
    lock, worm = EditContainer("Worm.Data06")
    worm.Energy = 75 
    worm.SfxBankName = "Pirate"
    worm.Name = "Shipmate Maddy"
    worm.Spawn = "spawn7"
    CloseContainer(lock)

   -- Worm 7, Team 0
    CopyContainer("Worm.Data04", "Worm.Data07")
    lock, worm = EditContainer("Worm.Data07")
    worm.Energy = 75  
    worm.SfxBankName = "Pirate"
    worm.Name = "Shipmate Elliot"
    worm.Spawn = "spawn8"
    CloseContainer(lock)

    SendMessage("WormManager.Reinitialise")
end

function SetupInventories()
    lock, inventory = EditContainer("Inventory.Team00") 
    inventory.Bazooka = 10
    inventory.Grenade = -1
    inventory.ClusterGrenade = 3
    inventory.Dynamite = 1
    inventory.HolyHandGrenade = 1
    inventory.Shotgun = 2
    inventory.Prod = -1
    inventory.FirePunch = 5
    inventory.HomingMissile = 1
    inventory.BananaBomb = 1
    inventory.SkipGo = -1
    
    CloseContainer(lock)
   
    lock, inventory = EditContainer("Inventory.Team01") 
    inventory.Bazooka = -1
    inventory.Grenade = -1
    inventory.ClusterGrenade = 2
    inventory.Dynamite = 1
    inventory.Airstrike = 1
    inventory.Shotgun = 2
    inventory.Prod = -1
    inventory.FirePunch = -1
    inventory.HomingMissile = 1
    inventory.SkipGo = -1
    CloseContainer(lock)
   
    lock, delays = EditContainer("Inventory.WeaponDelays")
    delays.HolyHandGrenade = 10
    delays.Airstrike = 8
    delays.BananaBomb = 5
    CloseContainer(lock)
end
