
   -- Mission Target Hunt

function Initialise()
    NewCrate = 1
    effects = 1
    camdone =  0
    TimeOut = 0
    KTime = 7000
    
    SetData("Particle.Rain.Prob", 100)
    SetData("Particle.Snow.Prob", 0)
    
    SendMessage("Commentary.NoDefault")
    SendStringMessage("Camera.Disable", "Blimp")
    SetData("Crate.GroundSnap", 1)
    SendMessage("EFMV.Start")
    -- Sets up mines and turn time
    SetData("Mine.DudProbabilty", 0.1)
    SetData("Mine.MinFuse", 1000)
    SetData("Mine.MaxFuse", 5000)
   
    SendMessage("HUD.HideTurnTime")
   
    SendStringMessage("Camera.Disable", "Track")
   
    SendMessage("GameLogic.PlaceObjects")
   
    SetData("Camera.StartOfTurnCamera","Default")
    SetData("Camera.GameOverCamera","Orbit")
  
    SetData("HotSeatTime", 0) -- no hotseat time
    SetData("RoundTime", 60000) -- no Game timer
    SetData("TurnTime", 0) 
    
    SetData("GameLogic.ArtilleryMode", 1)
    
    SetData("Land.Indestructable", 1)
    SetupWormsAndTeams()
    SetupInventories()
    StartGrantCam()
    MakeNewCrate()
end



function Weapon_PoweringUpStart()
end

function Weapon_Fired_Start()
end

function Weapon_Fired_End()
end

function StartFirstTurn()
    WaitUntilNoActivity = false
    SendMessage("EFMV.End")	
    SendMessage("Timer.StartGame")
    StartTurn()
end

function Worm_Died()
    SetData("CommentaryPanel.Comment", "Chall.Generic.Lose1")
    SendMessage("CommentaryPanel.ScriptText")
end

function TurnEnded()

    if TimeOut == 0 then
        SetData("CommentaryPanel.Comment", "Chall.Generic.Win1")
        SendMessage("CommentaryPanel.ScriptText")
        SetData("Camera.Path.IgnoreInput", 1)
        
        Result()
    else
        Result()
    end
end


--///////////////////////////////////////////////////////////////
--//            Check for which award you get                  //
--///////////////////////////////////////////////////////////////

function Result()  
    SetData("Camera.Path.IgnoreInput", 1)
    
    SetData("MCa.LastGameTime", GetData("ElapsedRoundTime"))
    timetook = GetData("ElapsedRoundTime")
    goldtime = GetData("MCa.BestGold")
    silvertime = GetData("MCa.BestSilver")
    bronzetime = GetData("MCa.BestBronze")
     
    if timetook > bronzetime then
        Movie = 1
        if timetook > silvertime then
            Movie = 2
            if timetook > goldtime then
                Movie = 3
            end
        end
    end

    if Movie == 1 then
        SetData("GameOver.AwardMovie","bronze")
    elseif Movie == 2 then
        SetData("GameOver.AwardMovie","silver")
    elseif Movie == 3 then
        SetData("GameOver.AwardMovie","gold")
    end
    
    SendMessage("GameLogic.Challenge.Result")
end


function SetupWormsAndTeams()
    GM = QueryContainer("GM.GameInitData")

    lock, team = EditContainer("Team.Data00") 
    team.Active = true
    team.Name = GM.T1_Name
    team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave
    team.TeamColour = 0
    CloseContainer(lock)

    lock, worm = EditContainer("Worm.Data00") 
    worm.Active = true
    worm.Name = GM.T1_W1_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "wspawn1"
    worm.Energy = 1
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    CloseContainer(lock) 
    SendMessage("WormManager.Reinitialise")
end

function Crate_Destroyed()
    MakeNewCrate()
end

function MakeNewCrate()
    RoundTimeRemaining = GetData("RoundTimeRemaining")
    SetData("RoundTimeRemaining", RoundTimeRemaining + KTime)

    if NewCrate == 1 then
	SetData("Crate.Spawn", "target1")
        SetData("Crate.Type", "Target")
        SetData("Crate.Pushable", 0)        
	SetData("Crate.Index", 1)
        SetData("Crate.TeamCollectable", 2)
	SetData("Crate.NumContents", 0)
	SendMessage("GameLogic.CreateCrate")
    elseif NewCrate == 2 then
        SetData("Crate.Spawn", "target2")
        SetData("Crate.Type", "Target")
        SetData("Crate.Pushable", 0)        
	SetData("Crate.Index", 2)
	SetData("Crate.NumContents", 0)
	SendMessage("GameLogic.CreateCrate")      
    elseif NewCrate == 3 then
     	SetData("Crate.Spawn", "target3")
        SetData("Crate.Type", "Target")
        SetData("Crate.Pushable", 0)        
	SetData("Crate.Index", 3)
	SetData("Crate.NumContents", 0)
	SendMessage("GameLogic.CreateCrate")
	SetData("CommentaryPanel.Comment", "Chall.Assault1.game1")
        SendMessage("CommentaryPanel.ScriptText")
        fancyeffects()       
    elseif NewCrate == 4 then
	SetData("Crate.Spawn", "target4")
        SetData("Crate.Type", "Target")
        SetData("Crate.Pushable", 0)        
	SetData("Crate.Index", 4)
	SetData("Crate.NumContents", 0)
	SendMessage("GameLogic.CreateCrate")
	SetData("CommentaryPanel.Comment", "Chall.Assault1.game1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif NewCrate == 5 then
     	SetData("Crate.Spawn", "target5")
        SetData("Crate.Type", "Target")
        SetData("Crate.Pushable", 0)        
	SetData("Crate.Index", 5)
	SetData("Crate.NumContents", 0)
	SendMessage("GameLogic.CreateCrate")
    elseif NewCrate == 6 then
     	SetData("Crate.Spawn", "target6")
        SetData("Crate.Type", "Target")
        SetData("Crate.Pushable", 0)        
	SetData("Crate.Index", 6)
	SetData("Crate.NumContents", 0)
	SendMessage("GameLogic.CreateCrate")
        fancyeffects()     
    elseif NewCrate == 7 then
     	SetData("Crate.Spawn", "target7")
        SetData("Crate.Type", "Target")
        SetData("Crate.Pushable", 0)        
	SetData("Crate.Index", 7)
	SetData("Crate.NumContents", 0)
	SendMessage("GameLogic.CreateCrate")
    elseif NewCrate == 8 then
    	SetData("Crate.Spawn", "target8")
        SetData("Crate.Type", "Target")
        SetData("Crate.Pushable", 0)        
	SetData("Crate.Index", 8)
	SetData("Crate.NumContents", 0)
	SendMessage("GameLogic.CreateCrate")
    elseif NewCrate == 9 then
    	SetData("Crate.Spawn", "target9")
        SetData("Crate.Type", "Target")
        SetData("Crate.Pushable", 0)        
	SetData("Crate.Index", 9)
	SetData("Crate.NumContents", 0)
	SendMessage("GameLogic.CreateCrate")    
    elseif NewCrate == 10 then
     	SetData("Crate.Spawn", "target10")
        SetData("Crate.Type", "Target")
        SetData("Crate.Pushable", 0)        
	SetData("Crate.Index", 10)
	SetData("Crate.NumContents", 0)
	SendMessage("GameLogic.CreateCrate")	
	SetData("CommentaryPanel.Comment", "missrum.game5")
        SendMessage("CommentaryPanel.ScriptText")
    elseif NewCrate == 11 then
     	SetData("Crate.Spawn", "target11")
        SetData("Crate.Type", "Target")
        SetData("Crate.Pushable", 0)        
	SetData("Crate.Index", 11)
	SetData("Crate.NumContents", 0)
	SendMessage("GameLogic.CreateCrate")	
	SetData("CommentaryPanel.Comment", "Chall.Assault1.game1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif NewCrate == 12 then
     	SetData("Crate.Spawn", "target12")
        SetData("Crate.Type", "Target")
        SetData("Crate.Pushable", 0)        
	SetData("Crate.Index", 12)
	SetData("Crate.NumContents", 0)
	SendMessage("GameLogic.CreateCrate")	
        fancyeffects()    
    elseif NewCrate == 13 then
     	SetData("Crate.Spawn", "target13")
        SetData("Crate.Type", "Target")
        SetData("Crate.Pushable", 0)        
	SetData("Crate.Index", 13)
	SetData("Crate.NumContents", 0)
	SendMessage("GameLogic.CreateCrate")
    elseif NewCrate == 14 then
     	SetData("Crate.Spawn", "target14")
        SetData("Crate.Type", "Target")
        SetData("Crate.Pushable", 0)        
	SetData("Crate.Index", 14)
	SetData("Crate.NumContents", 0)
	SendMessage("GameLogic.CreateCrate")	
	SetData("CommentaryPanel.Comment", "Chall.Assault1.game1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif NewCrate == 15 then
    	SetData("Crate.Spawn", "target15")
        SetData("Crate.Type", "Target")
        SetData("Crate.Pushable", 0)        
	SetData("Crate.Index", 15)
	SetData("Crate.NumContents", 0)
	SendMessage("GameLogic.CreateCrate")	
    elseif NewCrate == 16 then
     	SetData("Crate.Spawn", "target16")
        SetData("Crate.Type", "Target")
        SetData("Crate.Pushable", 0)        
	SetData("Crate.Index", 16)
	SetData("Crate.NumContents", 0)
	SendMessage("GameLogic.CreateCrate")

        fancyeffects()
	NewCrate = 1
        --bm1
        if KTime > 1000 then
            KTime = KTime - 1000
        end
    end
    
    NewCrate = NewCrate + 1
end


function SetupInventories()
   -- sets up a default container and adds our selection to it
   lock, inventory = EditContainer("Inventory.Team.Default") 
   inventory.Shotgun = -1
   CloseContainer(lock) -- must close the container ASAP

   CopyContainer("Inventory.Team.Default", "Inventory.Team00")
   CopyContainer("Inventory.Team.Default", "Inventory.Team01")

   lock, delays = EditContainer("Inventory.WeaponDelays") 
   CloseContainer(lock)

end

function fancyeffects()

    if effects == 1 then
        effects = effects + 1
        
        SetData("Particle.DetailObject", "Cam5")
        SetData("Particle.Name", "Part_Jeggflash")
        SendMessage("Particle.NewEmitter")
        id99 = GetData("Particle.Handle")
                
    
        SetData("Particle.DetailObject", "white1")
        SetData("Particle.Name", "Part_LightningWhiteout")
        SendMessage("Particle.NewEmitter")
        id399 = GetData("Particle.Handle") 

    elseif effects == 2 then
        effects = effects + 1

    elseif effects == 3 then
        effects = effects + 1

    elseif effects == 4 then
        effects = effects + 1
    
        SetData("Particle.DetailObject", "Cam5")
        SetData("Particle.Name", "Part_Jeggflash")
        SendMessage("Particle.NewEmitter")
        id99 = GetData("Particle.Handle")
            
    
        SetData("Particle.DetailObject", "white1")
        SetData("Particle.Name", "Part_LightningWhiteout")
        SendMessage("Particle.NewEmitter")
        id399 = GetData("Particle.Handle") 

        effects = 1
    end

end


function StartGrantCam()
    CameraFly = 1
       SetData("CommentaryPanel.Comment", "Chall.Shotgun1.Intro1")
    SendMessage("CommentaryPanel.ScriptText")
   
    SendIntMessage("Worm.ResetAnim", 0)
    SetData("Worm.ScriptAnim", "Idle_14_Periscope")
    SendIntMessage("Worm.QueueAnim", 0)
    SetData("Camera.Path.Knots.Position", "KelPos1,KelPos2")
    SetData("Camera.Path.Knots.LookAt", "KelLook1")
    SetData("Camera.Path.Loop.LookAt", 0) 
    SetData("Camera.Path.Tension.Position", -0.6)
    SetData("Camera.Path.Steps.Position",500)  
    SetData("Camera.Path.Steps.LookAt",350)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("camera2", 5000)
end

function camera2()
  SetData("CommentaryPanel.Comment", "Chall.Shotgun1.Intro2")
   SendMessage("CommentaryPanel.ScriptText")
   
    SetData("Camera.Path.Knots.Position", "KelPos3a,KelPos4")
    SetData("Camera.Path.Knots.LookAt", "KelLook1")
    SetData("Camera.Path.Loop.LookAt", 0) 
    SetData("Camera.Path.Tension.Position", -0.6)
    SetData("Camera.Path.Steps.Position",400)  
    SetData("Camera.Path.Steps.LookAt",350)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("camera3", 3500)
end

function camera3()
  SetData("CommentaryPanel.Comment", "Chall.Shotgun1.Intro3")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "KelPos2,KelPos3")
    SetData("Camera.Path.Knots.LookAt", "KelLook2")
    SetData("Camera.Path.Loop.LookAt", 0) 
    SetData("Camera.Path.Tension.Position", -0.6)
    SetData("Camera.Path.Steps.Position",400)  
    SetData("Camera.Path.Steps.LookAt",350)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("camera4", 4000)
end


function camera4()
    SendIntMessage("Worm.ResetAnim", 1)
    SetData("Worm.ScriptAnim", "DrawShotgun")
    SendIntMessage("Worm.QueueAnim", 1)
    SetData("Camera.Path.Knots.Position", "KelPos5,KelPos6")
    SetData("Camera.Path.Knots.LookAt", "KelLook3")
    SetData("Camera.Path.Loop.LookAt", 0) 
    SetData("Camera.Path.Tension.Position", -0.6)
    SetData("Camera.Path.Steps.Position",450)  
    SetData("Camera.Path.Steps.LookAt",350)
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("startt", 4000)
end

function checkteam()
-- PC: the current team value is now called CurrentTeamIndex
    Team = GetData("CurrentTeamIndex")
    if Team == 0 then
        stopteam()
   end
end

function stopteam()
   --SendStringMessage("Input.DisableGroup", "WormMoving")
    SetData("GameLogic.ArtilleryMode", 1)
end


function startt()
    SendMessage("EFMV.End")

    camdone =  1
    StartFirstTurn()

end

function Camera_Path_Stopped()

    if CameraFly == 1 then
        CameraFly = 0
        CancelTimer(CamLoop)
        if TimerControl == 1 then
            CancelTimer(TextTime)
            TimerControl = 0
        end
        SendMessage("EFMV.End")
        StartFirstTurn()
    end
end


function Timer_GameTimedOut()
    TimeOut = 1
    
    SendMessage("Weapon.Delete")
    SendMessage("Weapon.DisableWeaponChange")
    EndTurn()
    
    SetData("Camera.Path.IgnoreInput", 1)
    
    SetData("CommentaryPanel.Comment", "Chall.Generic.Win3")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("CommentaryPanel.Comment", "Chall.Generic.Win1")
    SendMessage("CommentaryPanel.ScriptText")
    
end
