-- Funfair mission.  Collect the Mines contained in crates from about the landscape and
-- use one mine as payment at each of the three ticket booths.
-- * After each 'marker' hidden in the ticket booth is destroyed the relevant CPU Worm's
--   weapon inventory is emptied so they can no longer attack the human worm.
-- * The mission is completed successfully when all three ticket booth markers are destroyed.
-- * EGG: To unlock the Easter Egg for this mission the player must complete successfully without destroying
--   any part of any of the ticket booths on the landscape.
-- ! Mission needs the triggered sound effects which Bjorn will eventually provide.

function Initialise()
--QA still need to provide some times...
    bronzetime = (60 * 1000) * 999
    silvertime = (60 * 1000) * 3.5
    goldtime = 195000
    SetData("Mine.DudProbabilty", 0.0)
    SetData("Mine.MinFuse", 3000)
    SetData("Mine.MaxFuse", 3000)

    SetData("Camera.StartOfTurnCamera","Default")
    SetData("Camera.GameOverCamera", "")
    
    SendMessage("EFMV.Start")
    SendMessage("GameLogic.ResetTriggerParams")

    SetData("Crate.Spawn", "Grenade1")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kWeaponLandmine")
    SetData("Crate.Pushable", 0)
    SetData("Crate.TeamDestructible", 0)
    SetData("Crate.GroundSnap", 1)
    SetData("Crate.Index", 1)
    SendMessage("GameLogic.CreateCrate")

    SetData("Crate.Spawn", "Grenade2")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kWeaponLandmine")
    SetData("Crate.Pushable", 0)
    SetData("Crate.TeamDestructible", 0)
    SetData("Crate.GroundSnap", 1)
    SetData("Crate.Index", 1)
    SendMessage("GameLogic.CreateCrate")

    SetData("Crate.Spawn", "Grenade3")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kWeaponLandmine")
    SetData("Crate.Pushable", 0)
    SetData("Crate.TeamDestructible", 0)
    SetData("Crate.GroundSnap", 1)
    SetData("Crate.Index", 1)
    SendMessage("GameLogic.CreateCrate")

    SetData("Crate.Spawn", "Parachutes")
    SetData("Crate.Type", "Utility")
    SetData("Crate.Contents", "kUtilityParachute")
    SetData("Crate.Pushable", 0)
    SetData("Crate.TeamDestructible", 10)
    SetData("Crate.NumContents", 1)
    SetData("Crate.GroundSnap", 1)
    SetData("Crate.Index", 0)
    SendMessage("GameLogic.CreateCrate")

    SetData("Trigger.Spawn", "Marker1")
    SetData("Trigger.Radius", 30.5)
    SetData("Trigger.Index", 100)
    SetData("Trigger.PayloadCollect",0)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.Visibility", 0)
    SetData("Trigger.TeamDestroy",10)
    SetData("Trigger.AffectsAI",1)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "Marker1A")
    SetData("Trigger.Radius", 30.5)
    SetData("Trigger.Index", 100)
    SetData("Trigger.PayloadCollect",0)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.Visibility", 0)
    SetData("Trigger.TeamDestroy",10)
    SetData("Trigger.AffectsAI",1)
    SendMessage("GameLogic.CreateTrigger")

    SetData("Trigger.Spawn", "Marker1B")
    SetData("Trigger.Radius", 30.5)
    SetData("Trigger.Index", 100)
    SetData("Trigger.PayloadCollect",0)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.Visibility", 0)
    SetData("Trigger.TeamDestroy",10)
    SetData("Trigger.AffectsAI",1)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "Marker2")
    SetData("Trigger.Radius", 30.5)
    SetData("Trigger.Index", 101)
    SetData("Trigger.PayloadCollect",0)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.Visibility", 0)
    SetData("Trigger.TeamDestroy",10)
    SetData("Trigger.AffectsAI",1)
    SendMessage("GameLogic.CreateTrigger")

    SetData("Trigger.Spawn", "Marker2A")
    SetData("Trigger.Radius", 30.5)
    SetData("Trigger.Index", 101)
    SetData("Trigger.PayloadCollect",0)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.Visibility", 0)
    SetData("Trigger.TeamDestroy",10)
    SetData("Trigger.AffectsAI",1)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "Marker2B")
    SetData("Trigger.Radius", 30.5)
    SetData("Trigger.Index", 101)
    SetData("Trigger.PayloadCollect",0)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.Visibility", 0)
    SetData("Trigger.TeamDestroy",10)
    SetData("Trigger.AffectsAI",1)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "Marker3")
    SetData("Trigger.Radius", 30.5)
    SetData("Trigger.Index", 102)
    SetData("Trigger.PayloadCollect",0)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.Visibility", 0)
    SetData("Trigger.TeamDestroy",10)
    SetData("Trigger.AffectsAI",1)
    SendMessage("GameLogic.CreateTrigger")

    SetData("Trigger.Spawn", "Marker3A")
    SetData("Trigger.Radius", 30.5)
    SetData("Trigger.Index", 102)
    SetData("Trigger.PayloadCollect",0)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.Visibility", 0)
    SetData("Trigger.TeamDestroy",10)
    SetData("Trigger.AffectsAI",1)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "Marker3B")
    SetData("Trigger.Radius", 30.5)
    SetData("Trigger.Index", 102)
    SetData("Trigger.PayloadCollect",0)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.Visibility", 0)
    SetData("Trigger.TeamDestroy",10)
    SetData("Trigger.AffectsAI",1)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "DestroyCheck1")
    SetData("Trigger.Radius", 20.5)
    SetData("Trigger.Index", 110)
    SetData("Trigger.PayloadCollect",10)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.Visibility", 0)
    SetData("Trigger.TeamDestroy",0)
    SetData("Trigger.AffectsAI",1)
    SendMessage("GameLogic.CreateTrigger")

    SetData("Trigger.Spawn", "DestroyCheck2")
    SetData("Trigger.Radius", 20.5)
    SetData("Trigger.Index", 111)
    SetData("Trigger.PayloadCollect",10)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.Visibility", 0)
    SetData("Trigger.TeamDestroy",0)
    SetData("Trigger.AffectsAI",1)
    SendMessage("GameLogic.CreateTrigger")

    SetData("Trigger.Spawn", "DestroyCheck3")
    SetData("Trigger.Radius", 20.5)
    SetData("Trigger.Index", 112)
    SetData("Trigger.PayloadCollect",10)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.Visibility", 0)
    SetData("Trigger.TeamDestroy",0)
    SetData("Trigger.AffectsAI",1)
    SendMessage("GameLogic.CreateTrigger")

    SetData("Trigger.Spawn", "DontFall")
    SetData("Trigger.Radius", 27)
    SetData("Trigger.Index", 120)
    SetData("Trigger.PayloadCollect",10)
    SetData("Trigger.TeamCollect", 0)
    SetData("Trigger.Visibility", 0)
    SetData("Trigger.TeamDestroy",10)
    SetData("Trigger.AffectsAI",0)
    SendMessage("GameLogic.CreateTrigger")

    SetData("Crate.Spawn", "Girders")
    SetData("Crate.Type", "Utility")
    SetData("Crate.Contents", "kUtilityGirder")
    SetData("Crate.Pushable", 0)
    SetData("Crate.TeamDestructible", 10)
    SetData("Crate.NumContents", 1)
    SetData("Crate.GroundSnap", 1)
    SetData("Crate.Index", 0)
    SendMessage("GameLogic.CreateCrate")

    --SetData("Trigger.Spawn", "CrateProtect1")
    --SetData("Trigger.Radius", 45)
    --SetData("Trigger.Index", 121)
    --SetData("Trigger.PayloadCollect",10)
    --SetData("Trigger.TeamCollect", 10)
    --SetData("Trigger.Visibility", 0)
    --SetData("Trigger.TeamDestroy",10)
    --SetData("Trigger.AffectsAI",1)
    --SendMessage("GameLogic.CreateTrigger")
    
    --SetData("Trigger.Spawn", "CrateProtect2")
    --SetData("Trigger.Radius", 45)
    --SetData("Trigger.Index", 122)
    --SetData("Trigger.PayloadCollect",10)
    --SetData("Trigger.TeamCollect", 10)
    --SetData("Trigger.Visibility", 0)
    --SetData("Trigger.TeamDestroy",10)
    --SetData("Trigger.AffectsAI",1)
    --SendMessage("GameLogic.CreateTrigger")
    
    --SetData("Trigger.Spawn", "CrateProtect3")
    --SetData("Trigger.Radius", 45)
    --SetData("Trigger.Index", 123)
    --SetData("Trigger.PayloadCollect",10)
    --SetData("Trigger.TeamCollect", 10)
    --SetData("Trigger.Visibility", 0)
    --SetData("Trigger.TeamDestroy",10)
    --SetData("Trigger.AffectsAI",1)
    --SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "ProtectMarker1")
    SetData("Trigger.Radius", 85)
    SetData("Trigger.Index", 124)
    SetData("Trigger.PayloadCollect",10)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.Visibility", 0)
    SetData("Trigger.TeamDestroy",10)
    SetData("Trigger.AffectsAI",1)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "ProtectMarker2")
    SetData("Trigger.Radius", 85)
    SetData("Trigger.Index", 125)
    SetData("Trigger.PayloadCollect",10)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.Visibility", 0)
    SetData("Trigger.TeamDestroy",10)
    SetData("Trigger.AffectsAI",1)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "ProtectMarker3")
    SetData("Trigger.Radius", 85)
    SetData("Trigger.Index", 126)
    SetData("Trigger.PayloadCollect",10)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.Visibility", 0)
    SetData("Trigger.TeamDestroy",10)
    SetData("Trigger.AffectsAI",1)
    SendMessage("GameLogic.CreateTrigger")
    
    SendMessage("GameLogic.PlaceObjects")

    SetData("Crate.Spawn", "Girders2")
    SetData("Crate.Type", "Utility")
    SetData("Crate.Contents", "kUtilityGirder")
    SetData("Crate.Pushable", 0)
    SetData("Crate.TeamDestructible", 10)
    SetData("Crate.NumContents", 1)
    SetData("Crate.GroundSnap", 1)
    SetData("Crate.Index", 0)
    SendMessage("GameLogic.CreateCrate")
    
-- this variable is set to 1 if any of the triggers inside the ticket booths are destroyed (for easter egg)
    TicketBoothDestroyed = 0
-- this is the counter used to check to see how many crates are destroyed   
    allcrates = 0
    CameraFly = 1
    CheshWinner = 0
    MineOnLand = 0
    CratePresent = 0
    CrateCycle = 1
    TotalCratesCollected = 0
    Switch = 0

    SetData("TurnTime", 30000)
    SetData("HotSeatTime", 3000)
    SetData("RoundTime", 900000)

    SetupWormsAndTeams()
    SetupInventories()
    Firework()
    OneFlyBy()
end

function Camera_Path_Stopped()
    if CameraFly == 1 then
        SendMessage("Commentary.Clear")
        SendMessage("EFMV.End")
        CameraFly = 0
        CancelTimer(CamLoop)
        StartFirstTurn()
    end
end

function CameraFinished()
    SendMessage("EFMV.End")
    CameraFly = 0
    StartFirstTurn()
end

function OneFlyBy()
    SetData("CommentaryPanel.Comment", "Miss.Funfair.game1")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Flyby1,Flyby2")
    SetData("Camera.Path.Knots.LookAt", "Flyby1LookAt1,Flyby1LookAt2")
    SetData("Camera.Path.Steps.Position",450)
    SetData("Camera.Path.Steps.LookAt",450) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("OneFlyBy2", 4000)
end

function OneFlyBy2()
    SetData("Camera.Path.Knots.Position", "Flyby3,Flyby4")
    SetData("Camera.Path.Knots.LookAt", "Flyby2LookAt1,Flyby2LookAt2")
    SetData("Camera.Path.Steps.Position",400)
    SetData("Camera.Path.Steps.LookAt",400) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("MakeCamera", 4000)
end

function MakeCamera()
    SetData("CommentaryPanel.Comment", "Miss.Funfair.game2")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("CommentaryPanel.Comment", "Miss.Funfair.game3")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("CommentaryPanel.Comment", "Miss.Funfair.game4")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Cam1")
    SetData("Camera.Path.Knots.LookAt", "Cam1LookAt1,Cam1LookAt2")
    SetData("Camera.Path.Steps.LookAt",600) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("MakeCamera2", 4000)
end

function MakeCamera2()
    SetData("Camera.Path.Knots.Position", "Cam2")
    SetData("Camera.Path.Knots.LookAt", "Cam2LookAt1,Cam2LookAt2")
    SetData("Camera.Path.Steps.LookAt",500) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("MakeCamera3", 3000)
end

function MakeCamera3()
    SetData("CommentaryPanel.Comment", "Miss.Funfair.game5")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Cam3")
    SetData("Camera.Path.Knots.LookAt", "Cam3LookAt1,Cam3LookAt2")
    SetData("Camera.Path.Steps.LookAt",500) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("MakeCamera4", 3000)
end

function MakeCamera4()
    SetData("CommentaryPanel.Comment", "Miss.Funfair.game6")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Cam4")
    SetData("Camera.Path.Knots.LookAt", "Cam4LookAt1")
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("MakeCamera5", 2000)

    SendIntMessage("Worm.ResetAnim", 1)
    SetData("Worm.ScriptAnim", "Taunt1")
    SendIntMessage("Worm.QueueAnim", 1)
end

function MakeCamera5()
    SetData("CommentaryPanel.Comment", "Miss.Funfair.game7")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("CommentaryPanel.Comment", "Miss.Funfair.game8")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Cam5")
    SetData("Camera.Path.Knots.LookAt", "Cam5LookAt1")
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("MakeCamera6", 2000)

    SendIntMessage("Worm.ResetAnim", 3)
    SetData("Worm.ScriptAnim", "Wave_Right")
    SendIntMessage("Worm.QueueAnim", 3)
end

function MakeCamera6()
    SetData("Camera.Path.Knots.Position", "Cam6")
    SetData("Camera.Path.Knots.LookAt", "Cam6LookAt1")
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("CameraFinished", 3000)
    
    SendIntMessage("Worm.ResetAnim", 2)
    SetData("Worm.ScriptAnim", "Bored1")
    SendIntMessage("Worm.QueueAnim", 2)
end

function TurnStarted()
    Team = GetData("CurrentTeamIndex")
    if Team == 1 then
        SetData("GameLogic.ArtilleryMode", 1)
    else
        SetData("GameLogic.ArtilleryMode", 0)
    end
end
 
function DoOncePerTurnFunctions()
  SpawnCrates()
end

function Crate_Collected()
    CrateIndex = GetData("Crate.Index")
    if CrateIndex == 1 then
        TotalCratesCollected = TotalCratesCollected + 1
    elseif CrateIndex == 2 then
        MineOnLand = 0
        CratePresent = 0
        CrateCycle = CrateCycle + 1
        if CrateCycle == 3 then
            CrateCycle = 1
        end
    end
end

function Crate_Destroyed()
    CrateIndex = GetData("Crate.Index")
    if CrateIndex == 1 then
        TotalCratesCollected = TotalCratesCollected + 1
    elseif CrateIndex == 2 then
        MineOnLand = 0
        CratePresent = 0
        CrateCycle = CrateCycle + 1
        if CrateCycle == 3 then
            CrateCycle = 1
        end
    end
end

function SpawnCrates()
    if TotalCratesCollected == 3 and CheshWinner == 0 then
        if CrateCycle == 1 and MineOnLand == 0 then
            SetData("Crate.Spawn", "ExtraMine1")
            SetData("Crate.Type", "Weapon")
            SetData("Crate.NumContents", 1)
            SetData("Crate.Contents", "kWeaponLandmine")
            SetData("Crate.Pushable", 0)
            SetData("Crate.TeamDestructible", 0)
            SetData("Crate.GroundSnap", 0)
            SetData("Crate.Index", 2)
            SendMessage("GameLogic.CreateCrate")
            MineOnLand = 1
            SetData("CommentaryPanel.Comment", "Miss.Timbers.game14")
            SendMessage("CommentaryPanel.ScriptText")
        elseif CrateCycle == 2 and MineOnLand == 0  then
            SetData("Crate.Spawn", "ExtraMine2")
            SetData("Crate.Type", "Weapon")
            SetData("Crate.NumContents", 1)
            SetData("Crate.Contents", "kWeaponLandmine")
            SetData("Crate.Pushable", 0)
            SetData("Crate.TeamDestructible", 0)
            SetData("Crate.GroundSnap", 0)
            SetData("Crate.Index", 2)
            SendMessage("GameLogic.CreateCrate")
            MineOnLand = 1
            SetData("CommentaryPanel.Comment", "Miss.Timbers.game14")
            SendMessage("CommentaryPanel.ScriptText")
        elseif CrateCycle == 3 and MineOnLand == 0 then
            SetData("Crate.Spawn", "ExtraMine3")
            SetData("Crate.Type", "Weapon")
            SetData("Crate.NumContents", 1)
            SetData("Crate.Contents", "kWeaponLandmine")
            SetData("Crate.Pushable", 0)
            SetData("Crate.TeamDestructible", 0)
            SetData("Crate.GroundSnap", 0)
            SetData("Crate.Index", 2)
            SendMessage("GameLogic.CreateCrate")
            MineOnLand = 1
            SetData("CommentaryPanel.Comment", "Miss.Timbers.game14")
            SendMessage("CommentaryPanel.ScriptText")
        end
    end
end

function Firework()        
    MakeRandomNumber()
    --bm1
    if MyRandomNumber == 1 then
        SetData("Particle.DetailObject", "Part_Firework")
        SetData("Particle.Name", "Part_Firework")
        SendMessage("Particle.NewEmitter")
    elseif MyRandomNumber == 2 then
        SetData("Particle.DetailObject", "Part_Firework1")
        SetData("Particle.Name", "Part_Firework")
        SendMessage("Particle.NewEmitter")
    elseif MyRandomNumber == 3 then
        SetData("Particle.DetailObject", "Part_Firework2")
        SetData("Particle.Name", "Part_Firework")
        SendMessage("Particle.NewEmitter")
    end
    
    StartTimer("Firework", 6000)
end

function MakeRandomNumber()
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 3) + 1
end

function endmissionsuccess()

    Result()
    
end


--///////////////////////////////////////////////////////////////
--//            Check for which award you get                  //
--///////////////////////////////////////////////////////////////


function Result()


    SetData("Camera.Path.IgnoreInput", 1)
    
    timetook = GetData("ElapsedRoundTime")
    
    if timetook < bronzetime then
        Movie = 1
 
        if timetook < silvertime then
            Movie = 2
            
            if timetook < goldtime then
                Movie = 3

                Key,Lock = EditContainer("L.L.Funfair")
                if Lock.Locked == true then
                    Lock.Locked = false
                    SetData("MCa.LockedName","L.L.Funfair")
                end
                CloseContainer(Key)
            end
        end
    end
    
    
    if Movie == 1 then
        SetData("MCa.LastGameTime", 1)
        SetData("GameOver.AwardMovie","bronze")
    elseif Movie == 2 then
        SetData("MCa.LastGameTime", 2)
        SetData("GameOver.AwardMovie","silver")
    elseif Movie == 3 then
        SetData("MCa.LastGameTime", 3)
        SetData("GameOver.AwardMovie","gold")
    end
    
    SendMessage("GameLogic.Mission.Success")

end



function endmissionfail()
    SendMessage("GameLogic.Mission.Failure")
end

function Trigger_PayloadCollected()
    TriggerIndex = GetData("Trigger.Index")    
    if TriggerIndex == 100 then
        SendIntMessage("GameLogic.DestroyTrigger", 100)
        lock, inventory = EditContainer("Inventory.Worm01") 
        inventory.FirePunch = 0
        inventory.Bazooka = 0
        CloseContainer(lock)
        allcrates = allcrates + 1
        cratetext()
    elseif TriggerIndex == 101 then 
        lock, inventory = EditContainer("Inventory.Worm02")
        SendIntMessage("GameLogic.DestroyTrigger", 101)
        inventory.FirePunch = 0
        inventory.Bazooka = 0
        CloseContainer(lock)
        allcrates = allcrates + 1
        cratetext()
    elseif TriggerIndex == 102 then
        SendIntMessage("GameLogic.DestroyTrigger", 102)
        lock, inventory = EditContainer("Inventory.Worm03") 
        inventory.FirePunch = 0
        inventory.Bazooka = 0
        CloseContainer(lock)
        allcrates = allcrates + 1
        cratetext()
    end
end

function Trigger_Destroyed()
    TicketBoothDestroyed = 1
end

function Trigger_Collected()
    TriggerIndex = GetData("Trigger.Index")    
    if TriggerIndex == 120 then
        SetData("CommentaryPanel.Comment", "Miss.Funfair.game14")
        SendMessage("CommentaryPanel.ScriptText")
    end
end

function CheckOneTeamVictory()
    TeamCount = GetData("TeamCount")
    WhichTeam = GetData("SurvivingTeamIndex")
    if TeamCount == 0 then
        if Switch == 0 then
            FailureMessages()
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
    elseif TeamCount == 1 and WhichTeam == 1 then
        if Switch == 0 then
            FailureMessages()
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
    elseif CheshWinner == 1 then
    
    else
        StartTurn()
    end
end


function TurnEnded()

    CheckOneTeamVictory()
    
    RoundTimeRemaining = GetData("RoundTimeRemaining")
    
    if RoundTimeRemaining == 0 or RoundTimeRemaining < 0 then
        if Switch == 0 then
            FailureMessages()
            --This needs to be a failure message
            SendMessage("GameLogic.Mission.Failure")
            Switch = 1
        end
    end
end

function cratetext()
    if allcrates == 1 then
        -- Text: That's one down, two to go!
        SetData("CommentaryPanel.Comment", "Miss.Funfair.game9")
        SendMessage("CommentaryPanel.ScriptText")
    elseif allcrates == 2 then
        -- Text: Just one more to get!
        SetData("CommentaryPanel.Comment", "Miss.Funfair.game10")
        SendMessage("CommentaryPanel.ScriptText")
    elseif allcrates == 3 then
        if Switch == 0 then
            -- Text: Congratulations
            CheshWinner = 1
            allcrates = 4
    
            if TicketBoothDestroyed == 0 then
                -- easter egg is unlocked.  EASTER EGG needs to be unlocked from here - this is easter egg text!
                Key,Lock = EditContainer("L.S.Gramps") --Gramps sound bank
                if Lock.Locked == true then
                    Lock.Locked = false
                    SetData("MCa.LockedName2","L.S.Gramps")
                end
                CloseContainer(Key)
                SetData("CommentaryPanel.Comment", "Miss.Funfair.game11")
                SendMessage("CommentaryPanel.ScriptText")
                SetData("CommentaryPanel.Comment", "Miss.Funfair.game13")
                SendMessage("CommentaryPanel.ScriptText")
                SetData("CommentaryPanel.Comment", "Miss.NotPC.egg8")
                SendMessage("CommentaryPanel.ScriptText")
                StartTimer("endmissionsuccess", 5000)
                
            elseif TicketBoothDestroyed == 1 then
                -- easter egg is not unlocked.
                SetData("CommentaryPanel.Comment", "Miss.Funfair.game11")
                SendMessage("CommentaryPanel.ScriptText")
                SetData("CommentaryPanel.Comment", "Miss.Funfair.game12")
                SendMessage("CommentaryPanel.ScriptText")
                SetData("CommentaryPanel.Comment", "Miss.Funfair.game13")
                SendMessage("CommentaryPanel.ScriptText")
                StartTimer("endmissionsuccess", 5000)
            end
            Switch = 1
        end
    end
end

function SetupWormsAndTeams()
   GM = QueryContainer("GM.GameInitData")
    lock, team = EditContainer("Team.Data00") 
    team.Active = true
    team.Name = GM.T1_Name
    team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave
    --team.SfxBankName = GM.T1_Speech
    team.TeamColour = 0
    CloseContainer(lock)

    lock, team = EditContainer("Team.Data01") 
    team.Active = true
    team.Name = "Carnival Folk"
    team.FlagGfxName = "103"
    team.IsAIControlled = true
    team.TeamColour = 1
    CloseContainer(lock)

    lock, worm = EditContainer("Worm.Data00")
    worm.Active = true
    worm.Name = GM.T1_W1_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "HumanWorm1"
    worm.Energy = 80
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    CloseContainer(lock)

    lock, worm = EditContainer("Worm.Data01")
    worm.Active = true
    worm.Name = "Patrick"
    worm.Spawn = "CPUWorm1"
    worm.SfxBankName = "Irish"
    worm.Energy = 200
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 1
    CloseContainer(lock)
    CopyContainer("AIParams.CPU4", "AIParams.Worm01")
    lock, worm = EditContainer("AIParams.Worm01") 
    worm.ForbidShotsWhenMightAffectAITrigger = 1
    CloseContainer(lock) 

    CopyContainer("Worm.Data01", "Worm.Data02")
    lock, worm = EditContainer("Worm.Data02")
    worm.Name = "Enrique"
    worm.Spawn = "CPUWorm2"
    worm.TeamIndex = 1
    CloseContainer(lock)
    CopyContainer("AIParams.Worm01", "AIParams.Worm02")

    CopyContainer("Worm.Data02", "Worm.Data03")
    lock, worm = EditContainer("Worm.Data03") 
    worm.Name = "Mar"
    worm.Spawn = "CPUWorm3"
    worm.TeamIndex = 1
    CloseContainer(lock)
    CopyContainer("AIParams.Worm01", "AIParams.Worm03")

    SendMessage("WormManager.Reinitialise")
end

function SetupInventories()
   -- set up the weapons for Human controlled team
    lock, inventory = EditContainer("Inventory.Team.Default") 
    --inventory.Parachute = 0
    --inventory.Jetpack = -1
    --inventory.Shotgun = -1
    --inventory.Grenade = -1
    inventory.SkipGo = -1
    --inventory.Surrender = -1
    CloseContainer(lock)
    CopyContainer("Inventory.Team.Default", "Inventory.Team00")
   
   -- set up the weapons for CPU controlled team 1
    lock, inventory = EditContainer("Inventory.Worm01") 
    inventory.FirePunch = -1
    inventory.Bazooka = -1
    inventory.SkipGo = -1
    CloseContainer(lock)
        
    lock, inventory = EditContainer("Inventory.Worm02") 
    inventory.FirePunch = -1
    inventory.Bazooka = -1
    inventory.SkipGo = -1
    CloseContainer(lock)
        
    lock, inventory = EditContainer("Inventory.Worm03") 
    inventory.FirePunch = -1
    inventory.Bazooka = -1
    inventory.SkipGo = -1
    CloseContainer(lock)
end


function FailureMessages()
    SendMessage("Commentary.Clear")
    
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 5) + 1
   
    if MyRandomNumber == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose1")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose2")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 3 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose3")
        SendMessage("CommentaryPanel.ScriptText") 
    elseif MyRandomNumber == 4 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif MyRandomNumber == 5 then
        SetData("CommentaryPanel.Comment", "Miss.Generic.Lose5")
        SendMessage("CommentaryPanel.ScriptText")        
    end
end