-- A Tomb with a View/Grave Danger:
-- * Firstly the player must locate a supply of Grenades, contained in crates, scattered about
--   the landscape.  The player must then determine which graves contain treasure and which
--   will curse them.  (this is done by way of a simple visual puzzle)  The overall goal is
--   to collect all four of the "Treasure" crates.

-- ! Ladder that leads down to beach crate near church is a bit fiddly.. platforms could do to be
--   flattened out.. beach should also extend all the way to land.
-- ! This mission needs the landscape looking at, needs another set of gravestones modelling
--   to make the puzzle trickier.  There should be no repeat head stones on the landscape.

-- ! This mission needs Easter Egg discovery linking in.
-- ! This mission needs how poison is displayed to be shown better (points should appear in one chunk)
-- ! This mission needs code to show that a Worm is poisoned with a graphical effect.

function Initialise()
    bronzetime = (60 * 1000) * 999
    silvertime = (60 * 1000) * 6
    goldtime = (60 * 1000) * 4.5
    SendMessage("HUD.HideTurnTime")
    SetData("HUD.Clock.DisplayRoundTime", 0)
    SetData("RoundTime",0)
    SetData("TurnTime", 0)
    SetData("HotSeatTime",0)

    SetData("Camera.StartOfTurnCamera","Default")
    SetData("Camera.GameOverCamera", "")

    SendMessage("EFMV.Start")

    SetData("Mine.DudProbabilty", 0.0)
    SetData("Mine.MinFuse", 2000)
    SetData("Mine.MaxFuse", 2000)
    SendMessage("GameLogic.PlaceObjects")
    SendMessage("GameLogic.ChangeWind")

    SetData("Particle.DetailObject", "Bell")
    SetData("Particle.Name", "Part_BellDark")
    SendMessage("Particle.NewEmitter")
    BellPart = GetData("Particle.Handle") 
    
    SetData("Trigger.Spawn", "Bell")
    SetData("Trigger.Radius", 20)
    SetData("Trigger.Index", 100)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
    FirstCrate = 0
    TreasureFound = 0
    TextControl = 0
    Switch = 0

    SendMessage("GameLogic.ResetTriggerParams")
    SetupWormsAndTeams()
    SetupInventories()

    SpawnCrates()
    SpawnTreasure()
    SpawnTriggers()
    MakeParticles()

    SetData("CommentaryPanel.Comment", "Miss.Grave.game0")
    SendMessage("CommentaryPanel.ScriptText")
    CameraFly = 1
    CameraFly2 = 0

    SetData("GameLogic.SuddenDamageMode", 1)
    OverHeadRail()
end

function SpawnCrates()
    SetData("Crate.Spawn", "CrateGrenade")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kWeaponGrenade")
    SetData("Crate.GroundSnap", 1)
    SetData("Crate.Index", 1)
    SendMessage("GameLogic.CreateCrate")

    SetData("Crate.Spawn", "CrateGrenade1")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kWeaponGrenade")
    SetData("Crate.Index", 2)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Crate.Spawn", "CrateGrenade2")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kWeaponGrenade")
    SetData("Crate.Index", 3)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Crate.Spawn", "CrateGrenade3")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kWeaponGrenade")
    SetData("Crate.Index", 4)
    SendMessage("GameLogic.CreateCrate")

    SetData("Crate.Spawn", "CrateGrenade4")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kWeaponGrenade")
    SetData("Crate.Index", 5)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Crate.Spawn", "CrateGrenade5")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kWeaponGrenade")
    SetData("Crate.Index", 6)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Crate.Spawn", "CrateGrenade6")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kWeaponGrenade")
    SetData("Crate.Index", 7)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Crate.Spawn", "CrateGrenade7")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kWeaponGrenade")
    SetData("Crate.Index", 8)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Crate.Spawn", "CrateGrenade8")
    SetData("Crate.Type", "Weapon")
    SetData("Crate.NumContents", 1)
    SetData("Crate.Contents", "kWeaponGrenade")
    SetData("Crate.Index", 9)
    SendMessage("GameLogic.CreateCrate")
end

function SpawnTreasure()
    SetData("Crate.Spawn", "Treasure1")
    SetData("Crate.Type", "Health")
    SetData("Crate.NumContents", 5)
    SetData("Crate.GroundSnap", 1)
    SetData("Crate.Index", 1)
    SetData("Crate.Scale", 1.2)
    SetData("Crate.Index", 10)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Crate.Spawn", "Treasure2")
    SetData("Crate.Type", "Health")
    SetData("Crate.NumContents", 5)
    SetData("Crate.GroundSnap", 1)
    SetData("Crate.Index", 1)
    SetData("Crate.Scale", 1.2)
    SetData("Crate.Index", 20)
    SendMessage("GameLogic.CreateCrate")

    SetData("Crate.Spawn", "Treasure3")
    SetData("Crate.Type", "Health")
    SetData("Crate.NumContents", 5)
    SetData("Crate.GroundSnap", 1)
    SetData("Crate.Index", 1)
    SetData("Crate.Scale", 1.2)
    SetData("Crate.Index", 30)
    SendMessage("GameLogic.CreateCrate")
    
    SetData("Crate.Spawn", "Treasure4")
    SetData("Crate.Type", "Health")
    SetData("Crate.NumContents", 5)
    SetData("Crate.GroundSnap", 1)
    SetData("Crate.Index", 1)
    SetData("Crate.Scale", 1.2)
    SetData("Crate.Index", 40)
    SendMessage("GameLogic.CreateCrate")

    SendIntMessage("Crate.RadarHide", 10)
    SendIntMessage("Crate.RadarHide", 20)
    SendIntMessage("Crate.RadarHide", 30)
    SendIntMessage("Crate.RadarHide", 40)
end

function SpawnTriggers()
    SetData("Trigger.Spawn", "Trig1")
    SetData("Trigger.Radius", 6)
    SetData("Trigger.Index", 1)
    SetData("Trigger.TeamCollect", 10)
    SetData("Trigger.Visibility", 0)
    SetData("Trigger.HitPoints", 15)
    SendMessage("GameLogic.CreateTrigger")

    SetData("Trigger.Spawn", "Trig2")
    SetData("Trigger.Index", 2)
    SetData("Trigger.TeamCollect", 10)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "Trig3")
    SetData("Trigger.Index", 3)
    SetData("Trigger.TeamCollect", 10)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "Trig4")
    SetData("Trigger.Index", 4)
    SetData("Trigger.TeamCollect", 10)
    SendMessage("GameLogic.CreateTrigger")

    SetData("Trigger.Spawn", "Trig5")
    SetData("Trigger.Index", 5)
    SetData("Trigger.TeamCollect", 10)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "Trig6")
    SetData("Trigger.Index", 6)
    SetData("Trigger.TeamCollect", 10)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "Trig7")
    SetData("Trigger.Index", 7)
    SetData("Trigger.TeamCollect", 10)
    SendMessage("GameLogic.CreateTrigger")
    
    SetData("Trigger.Spawn", "Trig8")
    SetData("Trigger.Index", 8)
    SetData("Trigger.TeamCollect", 10)
    SendMessage("GameLogic.CreateTrigger")
  
    SetData("Trigger.Spawn", "Egg_Trig")
    SetData("Trigger.Radius", 5)
    SetData("Trigger.Index", 9)
    SetData("Trigger.TeamCollect", 10)
    SendMessage("GameLogic.CreateTrigger")
end

function MakeParticles()
    SetData("Particle.DetailObject", "Mist1")
    SetData("Particle.Name", "Part_Gravemist")
    SendMessage("Particle.NewEmitter")
    SetData("Particle.DetailObject", "Mist2")
    SetData("Particle.Name", "Part_Gravemist")
    SendMessage("Particle.NewEmitter")
    SetData("Particle.DetailObject", "Mist3")
    SetData("Particle.Name", "Part_Gravemist")
    SendMessage("Particle.NewEmitter")
    SetData("Particle.DetailObject", "Mist4")
    SetData("Particle.Name", "Part_Gravemist")
    SendMessage("Particle.NewEmitter")
    SetData("Particle.DetailObject", "Mist5")
    SetData("Particle.Name", "Part_Gravemist")
    SendMessage("Particle.NewEmitter")
    SetData("Particle.DetailObject", "Mist6")
    SetData("Particle.Name", "Part_Gravemist")
    SendMessage("Particle.NewEmitter")
    SetData("Particle.DetailObject", "Mist7")
    SetData("Particle.Name", "Part_Gravemist")
    SendMessage("Particle.NewEmitter")
    SetData("Particle.DetailObject", "Mist8")
    SetData("Particle.Name", "Part_Gravemist")
    SendMessage("Particle.NewEmitter")
    SetData("Particle.DetailObject", "Mist9")
    SetData("Particle.Name", "Part_Gravemist")
    SendMessage("Particle.NewEmitter")
end

function Camera_Path_Stopped()
    if CameraFly == 1 then
        SendMessage("EFMV.End")
        CameraFly = 0
        CancelTimer(CamLoop)
        StartFirstTurn()
    --elseif CameraFly2 == 1 then
    --    SendMessage("EFMV.End")
    --    CameraFly = 0
    --    SetData("CommentaryPanel.Comment", "Miss.Grave.game0")
    --    SendMessage("CommentaryPanel.ScriptText")
    --    StartFirstTurn()
    end
end

function CameraFinished()
    SendMessage("EFMV.End")
    CameraFly = 0
    StartFirstTurn()
end
-- cameras start here
function OverHeadRail()
    SetData("Camera.Path.Knots.Position", "NewCam1,NewCam2")
    SetData("Camera.Path.Knots.LookAt", "NewLookAt1,NewLookAt2")
    SetData("Camera.Path.Steps.Position",300)
    SetData("Camera.Path.Steps.LookAt",300) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("SlowPullBack", 2500)
end

function SlowPullBack()
    SetData("Camera.Path.Knots.Position", "Camera3,Camera4")
    SetData("Camera.Path.Knots.LookAt", "LookAtPoint3")
    SetData("Camera.Path.Steps.Position",400)
    SetData("Camera.Path.Steps.LookAt",400) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("PanGraves", 4000)
end

function PanGraves()
    SetData("CommentaryPanel.Comment", "Miss.Grave.game1")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Camera6")
    SetData("Camera.Path.Knots.LookAt", "Pan1,Pan3")
    SetData("Camera.Path.Steps.LookAt",400) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("PanGraves2", 3500)
end

function PanGraves2()
    SetData("CommentaryPanel.Comment", "Miss.Grave.game2")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Camera7")
    SetData("Camera.Path.Knots.LookAt", "Pan4,Pan6")
    SetData("Camera.Path.Steps.LookAt",400) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("LookAt", 3500)
end

function LookAt()
    SetData("Particle.DetailObject", "LightningEffect")
    SetData("Particle.Name", "Part_Lightning")
    SendMessage("Particle.NewEmitter")
    
    StartTimer("StrikeLight", 200)
    
    SetData("CommentaryPanel.Comment", "Miss.Grave.game3")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "Camera5")
    SetData("Camera.Path.Knots.LookAt", "LookAtPoint5")
    SendMessage("Camera.Path.Start")
    MakeRandomNumber()
    if MyRandomNumber == 1 then
        CamLoop = StartTimer("BeachStepCam", 3000)
    else
        CamLoop = StartTimer("ChurchCam", 3000)
    end
end

function StrikeLight()
    SetData("Particle.DetailObject", "white1")
    SetData("Particle.Name", "Part_LightningWhiteout")

    SendMessage("Particle.NewEmitter")
    id2 = GetData("Particle.Handle")
end

function BeachStepCam()
    SetData("CommentaryPanel.Comment", "Miss.Grave.game4")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "BeachStepCam1,BeachStepCam2")
    SetData("Camera.Path.Knots.LookAt", "BeachStepLookAt")
    SetData("Camera.Path.Steps.Position",300)
    SetData("Camera.Path.Steps.LookAt",300) 
    SendMessage("Camera.Path.Start")
    MakeRandomNumber()
    if MyRandomNumber == 1 then
        CamLoop = StartTimer("HouseCam", 2000)
    else
        CamLoop = StartTimer("TreeCam", 2000)
    end
end

function ChurchCam()
    SetData("CommentaryPanel.Comment", "Miss.Grave.game4")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "ChurchCam1,ChurchCam2")
    SetData("Camera.Path.Knots.LookAt", "ChurchLookAt")
    SetData("Camera.Path.Steps.Position",300)
    SetData("Camera.Path.Steps.LookAt",300) 
    SendMessage("Camera.Path.Start")
    MakeRandomNumber()
    if MyRandomNumber == 1 then
        CamLoop = StartTimer("HouseCam", 2000)
    else
        CamLoop = StartTimer("TreeCam", 2000)
    end
end

function HouseCam()
    SetData("CommentaryPanel.Comment", "Miss.Grave.game5")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "HouseCam1,HouseCam2")
    SetData("Camera.Path.Knots.LookAt", "HouseLookAt")
    SetData("Camera.Path.Steps.Position",300)
    SetData("Camera.Path.Steps.LookAt",300) 
    SendMessage("Camera.Path.Start")
    MakeRandomNumber()
    if MyRandomNumber == 1 then
        CamLoop = StartTimer("TombCam", 2000)
    else
        CamLoop = StartTimer("HouseBeachCam", 2000)
    end
end

function TreeCam()
    SetData("CommentaryPanel.Comment", "Miss.Grave.game5")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "TreeCam1,TreeCam2")
    SetData("Camera.Path.Knots.LookAt", "TreeLookAt")
    SetData("Camera.Path.Steps.Position",300)
    SetData("Camera.Path.Steps.LookAt",300) 
    SendMessage("Camera.Path.Start")
    MakeRandomNumber()
    if MyRandomNumber == 1 then
        CamLoop = StartTimer("TombCam", 2000)
    else
        CamLoop = StartTimer("HouseBeachCam", 2000)
    end
end

function TombCam()
    SetData("Camera.Path.Knots.Position", "TombCam1,TombCam2")
    SetData("Camera.Path.Knots.LookAt", "TombLookAt")
    SetData("Camera.Path.Steps.Position",300)
    SetData("Camera.Path.Steps.LookAt",300) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("LookAtShed", 2000)
end

function HouseBeachCam()
    SetData("Camera.Path.Knots.Position", "HouseBeachCam1,HouseBeachCam2")
    SetData("Camera.Path.Knots.LookAt", "HouseBeachLookAt")
    SetData("Camera.Path.Steps.Position",300)
    SetData("Camera.Path.Steps.LookAt",300) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("LookAtShed", 2000)
end

function LookAtShed()
    SetData("Camera.Path.Knots.Position", "ShedCam,ShedCam2")
    SetData("Camera.Path.Knots.LookAt", "ShedLookAt")
    SetData("Camera.Path.Steps.LookAt",800) 
    SendMessage("Camera.Path.Start")
    StartTimer("StopCamera", 2500)
    CamLoop = StartTimer("CameraFinished", 2500)
end

function MakeRandomNumber()
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 2) + 1
end
-- cameras end here

function TurnStarted()
	SelectRandomWind()
end

function Weapon_Fired_Start()
end

function Weapon_Fired_End()
   SendMessage("Weapon.Delete")
   SendMessage("Weapon.Create")
end

function Weapon_PoweringUpStart()
end

function StartFirstTurn()
   WaitUntilNoActivity = false
   SendMessage("Timer.StartGame")
   SendMessage("EFMV.End")
   StartTurn()
end

function TurnEnded()
    if Switch == 0 then
        StartTurn()
    end
end

function CheckOneTeamVictory()
end
--dontendturn

function Worm_Died()
    deadworm = GetData("DeadWorm.Id")
    if deadworm == 0 then
        SendMessage("Commentary.Clear")
        SetData("CommentaryPanel.Comment", "Miss.Apple.failed")
        SetData("CommentaryPanel.Delay",3000)
        SendMessage("CommentaryPanel.TimedText")
        Switch = 1
        endmissionfail()
    end
end

-- have a look to see which crates have been collected
function Crate_Collected()
    FirstCrate = FirstCrate + 1
    
    if FirstCrate == 1 then
        SetData("GameLogic.ArtilleryMode", 1)
        ExplainDigging()
    end

    CrateNumber = GetData("Crate.Index")
    if CrateNumber == 1 then
        if FirstCrate > 1 then
            SetData("CommentaryPanel.Comment", "Miss.Grave.game11")
            SendMessage("CommentaryPanel.ScriptText")
        end
    elseif CrateNumber == 2 then
        if FirstCrate > 1 then
            SetData("CommentaryPanel.Comment", "Miss.Grave.game11")
            SendMessage("CommentaryPanel.ScriptText")
        end
    elseif CrateNumber == 3 then
        if FirstCrate > 1 then
            SetData("CommentaryPanel.Comment", "Miss.Grave.game12")
            SendMessage("CommentaryPanel.ScriptText")
        end
    elseif CrateNumber == 4 then
        if FirstCrate > 1 then
            SetData("CommentaryPanel.Comment", "Miss.Grave.game11")
            SendMessage("CommentaryPanel.ScriptText")
        end
    elseif CrateNumber == 5 then
        if FirstCrate > 1 then
            SetData("CommentaryPanel.Comment", "Miss.Grave.game12")
            SendMessage("CommentaryPanel.ScriptText")
        end
    elseif CrateNumber == 6 then
        if FirstCrate > 1 then
            SetData("CommentaryPanel.Comment", "Miss.Grave.game12")
            SendMessage("CommentaryPanel.ScriptText")
        end
    elseif CrateNumber == 7 then
        if FirstCrate > 1 then            
            SetData("CommentaryPanel.Comment", "Miss.Grave.game12")
            SendMessage("CommentaryPanel.ScriptText")
        end
    elseif CrateNumber == 8 then
        if FirstCrate > 1 then            
            SetData("CommentaryPanel.Comment", "Miss.Grave.game11")
            SendMessage("CommentaryPanel.ScriptText")
        end
    elseif CrateNumber == 9 then
        if FirstCrate > 1 then            
            SetData("CommentaryPanel.Comment", "Miss.Grave.game12")
            SendMessage("CommentaryPanel.ScriptText")
        end
    elseif CrateNumber == 10 then
        TreasureFound = TreasureFound + 1
    elseif CrateNumber == 20 then
        TreasureFound = TreasureFound + 1
    elseif CrateNumber == 30 then
        TreasureFound = TreasureFound + 1
    elseif CrateNumber == 40 then
        TreasureFound = TreasureFound + 1
    end
    
    if TreasureFound == 3 then
        TextControl = TextControl + 1
        if TextControl == 1 then
            SendMessage("Commentary.Clear")
            SetData("CommentaryPanel.Comment", "Miss.Grave.game16")
            SendMessage("CommentaryPanel.ScriptText")
        end
    end
    
    if TreasureFound == 4 then
        SendMessage("Commentary.Clear")
        SendMessage("Commentary.NoDefault")
        SetData("CommentaryPanel.Comment", "Miss.Grave.game13")
        SendMessage("CommentaryPanel.ScriptText")
        SetData("CommentaryPanel.Comment", "Miss.Grave.game14")
        SendMessage("CommentaryPanel.ScriptText")
        endmissionsuccess()
    end
end

function Crate_Destroyed()
    CrateIndex = GetData("Crate.Index")
    if CrateIndex == 10 or CrateIndex == 20 or CrateIndex == 30 or CrateIndex == 40 then
        SendMessage("Commentary.Clear")
        SendMessage("Commentary.NoDefault")
        SetData("CommentaryPanel.Comment", "Miss.Showdown.Failed")
        SendMessage("CommentaryPanel.ScriptText")
        SetData("CommentaryPanel.Comment", "Miss.generic.fail")
        SendMessage("CommentaryPanel.ScriptText")
        endmissionfail()
    end
end

function ExplainDigging()
    SendMessage("EFMV.Start")
    DelayText()
    SetData("Camera.Path.Knots.Position", "MidGameCam,MidGameCam2")
    SetData("Camera.Path.Knots.LookAt", "MidGameLook")
    SetData("Camera.Path.Steps.Position",1200)
    SetData("Camera.Path.IgnoreInput", 1)
    SendMessage("Camera.Path.Start")
    SendMessage("GameLogic.PauseGame")
    StartTimer("EndExplain", 12000)
end

function EndExplain()
    SendMessage("EFMV.End")
    CameraFly = 0
    SendMessage("Camera.SetDefault")
    ResumeGame()
    SetData("GameLogic.ArtilleryMode", 0)
end

function DelayText()
    SetData("CommentaryPanel.Comment", "Miss.Grave.game18")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("CommentaryPanel.Comment", "Miss.Grave.game19")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("CommentaryPanel.Comment", "Miss.Grave.game20")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("CommentaryPanel.Comment", "Miss.Grave.game21")
    SendMessage("CommentaryPanel.ScriptText")
end

-- put this in to eat up any pending damage function.. 
function EndTurn()
   SendMessage("GameLogic.EndTurn")
  
   Activity = GetData("ObjectCount.Active")
   if Activity == 0 then
      SendMessage("Timer.StartPostActivity") -- pause
   else
      WaitUntilNoActivity = true
   end
end

function Trigger_Destroyed()
    TriggerIndex = GetData("Trigger.Index")

    if TriggerIndex == 1 then
        SendIntMessage("Crate.RadarDisplay", 10)
        SetData("Particle.DetailObject", "HUClod1")
	SetData("Particle.Name", "Part_Gravedust")
	SendMessage("Particle.NewEmitter")
        SetData("CommentaryPanel.Comment", "Miss.Grave.game6")
        SendMessage("CommentaryPanel.ScriptText")
        SetData("CommentaryPanel.Comment", "Miss.Grave.game9")
        SendMessage("CommentaryPanel.ScriptText")
        SetData("CommentaryPanel.Comment", "Miss.Grave.game10")
        SendMessage("CommentaryPanel.ScriptText")
    elseif TriggerIndex == 2 then
        -- BAD GRAVE
        SetData("Particle.DetailObject", "HUClod2")
	SetData("Particle.Name", "Part_Gravedust")
	SendMessage("Particle.NewEmitter")
        SetData("CommentaryPanel.Comment", "Miss.Grave.game6")
        SendMessage("CommentaryPanel.ScriptText")
        SetData("CommentaryPanel.Comment", "Miss.Grave.game7")
        SendMessage("CommentaryPanel.ScriptText")
        SetData("CommentaryPanel.Comment", "Miss.Grave.game8")
        SendMessage("CommentaryPanel.ScriptText")
    elseif TriggerIndex == 3 then
        SendIntMessage("Crate.RadarDisplay", 20)
        SetData("Particle.DetailObject", "HUClod3")
	SetData("Particle.Name", "Part_Gravedust")
	SendMessage("Particle.NewEmitter")
        SetData("CommentaryPanel.Comment", "Miss.Grave.game6")
        SendMessage("CommentaryPanel.ScriptText")
        SetData("CommentaryPanel.Comment", "Miss.Grave.game9")
        SendMessage("CommentaryPanel.ScriptText")
        SetData("CommentaryPanel.Comment", "Miss.Grave.game10")
        SendMessage("CommentaryPanel.ScriptText")
    elseif TriggerIndex == 4 then
        -- BAD GRAVE
        SetData("Particle.DetailObject", "HUClod4")
	SetData("Particle.Name", "Part_Gravedust")
	SendMessage("Particle.NewEmitter")
        SetData("CommentaryPanel.Comment", "Miss.Grave.game6")
        SendMessage("CommentaryPanel.ScriptText")
        SetData("CommentaryPanel.Comment", "Miss.Grave.game7")
        SendMessage("CommentaryPanel.ScriptText")
        SetData("CommentaryPanel.Comment", "Miss.Grave.game17")
        SendMessage("CommentaryPanel.ScriptText")
        SetData("Worm.Poison.Default", 5)
        SendIntMessage("Worm.Poison", 0)
        StartTimer("UpdatePoison", 3000)
        -- 4. Command to poision Worm here!
    elseif TriggerIndex == 5 then
        SendIntMessage("Crate.RadarDisplay", 30)
        SetData("Particle.DetailObject", "HUClod5")
	SetData("Particle.Name", "Part_Gravedust")
	SendMessage("Particle.NewEmitter")
        SetData("CommentaryPanel.Comment", "Miss.Grave.game6")
        SendMessage("CommentaryPanel.ScriptText")
        SetData("CommentaryPanel.Comment", "Miss.Grave.game9")
        SendMessage("CommentaryPanel.ScriptText")
        SetData("CommentaryPanel.Comment", "Miss.Grave.game10")
        SendMessage("CommentaryPanel.ScriptText")
    elseif TriggerIndex == 6 then
        SendIntMessage("Crate.RadarDisplay", 40)
        SetData("Particle.DetailObject", "HUClod6")
	SetData("Particle.Name", "Part_Gravedust")
	SendMessage("Particle.NewEmitter")
        SetData("CommentaryPanel.Comment", "Miss.Grave.game6")
        SendMessage("CommentaryPanel.ScriptText")
        SetData("CommentaryPanel.Comment", "Miss.Grave.game9")
        SendMessage("CommentaryPanel.ScriptText")
        SetData("CommentaryPanel.Comment", "Miss.Grave.game10")
        SendMessage("CommentaryPanel.ScriptText")
    elseif TriggerIndex == 7 then
        -- BAD GRAVE
        SetData("Particle.DetailObject", "HUClod7")
	SetData("Particle.Name", "Part_Gravedust")
	SendMessage("Particle.NewEmitter")
        SetData("CommentaryPanel.Comment", "Miss.Grave.game6")
        SendMessage("CommentaryPanel.ScriptText")
        SetData("CommentaryPanel.Comment", "Miss.Grave.game7")
        SendMessage("CommentaryPanel.ScriptText")
        CreateAirstrike()
    elseif TriggerIndex == 8 then
        -- BAD GRAVE
        SetData("Particle.DetailObject", "HUClod8")
	SetData("Particle.Name", "Part_Gravedust")
	SendMessage("Particle.NewEmitter")
        SetData("CommentaryPanel.Comment", "Miss.Grave.game6")
        SendMessage("CommentaryPanel.ScriptText")
        SetData("CommentaryPanel.Comment", "Miss.Grave.game7")
        SendMessage("CommentaryPanel.ScriptText")
        SetData("CommentaryPanel.Comment", "Miss.Grave.game17")
        SendMessage("CommentaryPanel.ScriptText")
        SetData("Mine.StartsMidAir", 1)
        SetData("Particle.DetailObject", "MineTele")
        SetData("Particle.Name", "EffectExplosion")
        SendMessage("Particle.NewEmitter")
        SendStringMessage("GameLogic.PlaceMine", "SM1")
        SendStringMessage("GameLogic.PlaceMine", "SM2")
        SendStringMessage("GameLogic.PlaceMine", "SM3")
        SendStringMessage("GameLogic.PlaceMine", "SM4")
        SendStringMessage("GameLogic.PlaceMine", "SM5")
        SendStringMessage("GameLogic.PlaceMine", "SM6")
        SendStringMessage("GameLogic.PlaceMine", "SM7")
        SendStringMessage("GameLogic.PlaceMine", "SM8")
        SendStringMessage("GameLogic.PlaceMine", "SM9")
        SendStringMessage("GameLogic.PlaceMine", "SM10")
        SendStringMessage("GameLogic.PlaceMine", "SM11")
        SendStringMessage("GameLogic.PlaceMine", "SM12")
        SendStringMessage("GameLogic.PlaceMine", "SM13")
        SendStringMessage("GameLogic.PlaceMine", "SM14")
        SendStringMessage("GameLogic.PlaceMine", "SM15")
        SendStringMessage("GameLogic.PlaceMine", "SM16")
        SetData("Mine.StartsMidAir", 0)
        --  8. Drop a mine on the Worm!
    elseif TriggerIndex == 9 then
        -- if this trigger is destroyed an easter egg is uncovered
        -- CHANGETEXT
        
        --SendIntMessage("Particle.DeleteEmitter",PartGhost)
        
        Key,Lock = EditContainer("L.S.Horror") --Horror sound bank
        if Lock.Locked == true then
            Lock.Locked = false
            SetData("MCa.LockedName3","L.S.Horror")
        end
        CloseContainer(Key)
        Key,Lock = EditContainer("L.P.Horror") --Horror Wormapedia
        if Lock.Locked == true then
            Lock.Locked = false
            SetData("MCa.LockedName2","L.P.Horror")
        end
        CloseContainer(Key)
        SetData("CommentaryPanel.Comment", "Highstakes.1")
        SendMessage("CommentaryPanel.ScriptText")
        SetData("CommentaryPanel.Comment", "Miss.NotPC.egg8")
        SendMessage("CommentaryPanel.ScriptText")
    elseif TriggerIndex == 100 then
        SendIntMessage("Particle.DeleteEmitter",BellPart)
    end
end

function UpdatePoison()
    worm = QueryContainer("Worm.Data00")
    if worm.Energy >= 1 then 
        -- dont apply any poison during this phase or the activity could be held up forever
        if WaitUntilNoActivity == false then
           SendMessage("Worm.ApplyPoison")
        end     
        -- However do start a timer for next time
        StartTimer("UpdatePoison", 3000)
    end
end

function CreateAirstrike()
    SendMessage("GameLogic.PauseGame")
    StartTimer("ResumeGame", 6500)
    SetData("Airstrike.Direction.Radians", 6.28)
    SetData("Airstrike.TargetEntity", "StrikeHere")
    SetData("Airstrike.WeaponProperties", "kWeaponAirstrike")
    SendMessage("GameLogic.CreateAirstrike")
end

function ResumeGame()
    SendMessage("GameLogic.ResumeGame")
end

function endmissionsuccess()
    Result()
end

--///////////////////////////////////////////////////////////////
--//            Check for which award you get                  //
--///////////////////////////////////////////////////////////////

function Result()


    SetData("Camera.Path.IgnoreInput", 1)
    
    timetook = GetData("ElapsedRoundTime")
    
    if timetook < bronzetime then
        Movie = 1
        if timetook < silvertime then
            Movie = 2
            if timetook < goldtime then
                Movie = 3
                Key,Lock = EditContainer("L.L.Graveyard") --unlock grave danger for multiplayer
                if Lock.Locked == true then
                    Lock.Locked = false
                    SetData("MCa.LockedName","L.L.Graveyard")
                end
                CloseContainer(Key)
            end
        end
    end
    
    
    if Movie == 1 then
        SetData("MCa.LastGameTime", 1)
        SetData("GameOver.AwardMovie","bronze")
    elseif Movie == 2 then
        SetData("MCa.LastGameTime", 2)
        SetData("GameOver.AwardMovie","silver")
    elseif Movie == 3 then
        SetData("MCa.LastGameTime", 3)
        SetData("GameOver.AwardMovie","gold")
    end
    
    SendMessage("GameLogic.Mission.Success")

end

function endmissionfail()
    SendMessage("GameLogic.Mission.Failure")
end

function SetupWormsAndTeams()
    GM = QueryContainer("GM.GameInitData")
    -- Activate Team 0
    lock, team = EditContainer("Team.Data00")
    team.Active = true
    team.Name = GM.T1_Name
    team.FlagGfxName = GM.T1_Flag
    team.GraveIndex = GM.T1_Grave
    -- team.SfxBankName = GM.T1_Speech
    team.TeamColour = 0
   
   
   CloseContainer(lock)

   -- Worm 0, Team 0
    lock, worm = EditContainer("Worm.Data00")
    worm.Active = true
   --worm.Name = "GraveDiggler"
    worm.Name = GM.T1_W1_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Energy = 100
    worm.Spawn = "HumanWorm1"
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    CloseContainer(lock) 
   
   SendMessage("WormManager.Reinitialise")
end

function SetupInventories()
    lock, inventory = EditContainer("Inventory.Team.Default")
    inventory.SkipGo = 0
    CloseContainer(lock)
    CopyContainer("Inventory.Team.Default", "Inventory.Team00")
end
