-- Pegasus: The player must hold all four locations keeping all CPU Worms out, and hold them until
-- the time expires.
-- * The player is armed with a misc arsenal.  They must hold all four locations until the clock counts
--   out making sure no CPU Worms stray into the area.  The mission will end successfully once the
--   time on the clock expires.  The mission will fail if any human controlled Worms die.
-- ! This mission needs text finalising in main file and translation.
-- ! This mission could do with Worm Select being enabled on the Worms.
-- ! There is a problem with entering and leaving the zones quickly - the text gets confusing as it's sent many
--   times.
-- Health crate index numbers start at 100

function Initialise()
    --*ATTENTION!!!* these times are estimates, they are NOT times from QA - they need replacing *ATTENTION!!!*
    bronzetime = (60 * 1000) * 999
    silvertime = (60 * 1000) * 11.5
    goldtime = (60 * 1000) * 11

    SendMessage("EFMV.Start")
    SendMessage("Commentary.NoDefault")
    SetData("RoundTime", 300000)
    SetData("TurnTime", 45000)
    SetData("HotSeatTime", 3000)
    SendMessage("GameLogic.RoundTime.Pause")
    SendMessage("GameLogic.ResetTriggerParams")
    SetData("Land.Indestructable", 1)
    
    SetData("Camera.StartOfTurnCamera","Default")
    SetData("Camera.GameOverCamera", "")
    
    nCPUBuilding = 1
    nPlayerBuilding = 2
    nCPUBridge = 3
    nPlayerBridge = 4
    nCPUGunArea = 5
    nPlayerGunArea = 6
    nCPUBoatArea = 7
    nPlayerBoatArea = 8
    Start1 = 0
    Switch2 = 0
    CamLoop1 = 0
    CamLoop2 = 0
    Camdone2 = 0

    nReinforcements = 0
    nMaxReinforcements = 3

    PlayerOwnsArea = 0
    TakenControl = 0
    MiniBreak = 0
    EFMVSequence = 1
    
    
    TrigIndex = 0
    
    TextControl = 0
    EnemyTextControl = 2
    CPUTextState = 0
    SpawnControl = 0
    nCPUControlled = 3
    nPlayerControlled = 0
    TurnsRemain = 5
    
    CPUOnGunArea = 1
    CPUOnBridge = 1
    CPUOnBoatArea = 1
    CPUOnBuilding = 1
    
    CPUInGunArea = 2
    CPUInBridge = 2
    CPUInBoatArea = 2
    CPUInBuilding = 2
    PlayerInGunArea = 2
    PlayerInBridge = 2
    PlayerInBoatArea = 2
    PlayerInBuilding = 2
    TrigCollector = 0
    CurrentWorm = 0
    TrigMem = 999
    GameOn = 1
    
    
    FlareBuilding = 0
    FlareGunArea = 0
    FlareBridge = 0
    FlareBoat = 0
    
    FBuilding = 0
    FGun = 0
    FBridge = 0
    FBoat = 0
    
    HealthGunArea = 0
    HealthBridge = 0
    HealthBoatArea = 0
    HealthBuilding = 0
    HealthRandomNumber = 0
    ControlIsOurs = 0
    
    Switch = 0

    CameraFly = 1

    TurnEndMarker = 0
    DeadCPU = 0
    DeadHuman = 0
    TurnIsOn = 0
    
    
    particles()
    WaterSplash()

    SelectRandomWind()
    SetupWormsAndTeams()
    SetupInventories()
    Line1()
end

function particles()
--    SetData("Particle.DetailObject", "GunSmoke")
--    SetData("Particle.Name", "Part_OilySmoke")
--    SendMessage("Particle.NewEmitter")
--    ids1 = GetData("Particle.Handle")
    
--    SetData("Particle.DetailObject", "FlakPart")
--    SetData("Particle.Name", "Part_Flak")
--    SendMessage("Particle.NewEmitter")
    

end

function WaterSplash()
    SplashRandomNumber()

    if MySplashRandom == 1 then
        SetData("Particle.DetailObject", "Charge1")
        SetData("Particle.Name", "Part_Depthcharge")
        SendMessage("Particle.NewEmitter")
    elseif MySplashRandom == 2 then
        SetData("Particle.DetailObject", "Charge2")
        SetData("Particle.Name", "Part_Depthcharge")
        SendMessage("Particle.NewEmitter")
    elseif MySplashRandom == 3 then
        SetData("Particle.DetailObject", "Charge3")
        SetData("Particle.Name", "Part_Depthcharge")
        SendMessage("Particle.NewEmitter")
    elseif MySplashRandom == 4 then
        SetData("Particle.DetailObject", "Charge4")
        SetData("Particle.Name", "Part_Depthcharge")
        SendMessage("Particle.NewEmitter")
    elseif MySplashRandom == 5 then
        SetData("Particle.DetailObject", "Charge5")
        SetData("Particle.Name", "Part_Depthcharge")
        SendMessage("Particle.NewEmitter")
    end
    
    StartTimer("WaterSplash", 3000)
end

function SplashRandomNumber()
    SendMessage("RandomNumber.Get")
    SplashRandom = GetData("RandomNumber.Uint")
    Print("SplashRandom ", SplashRandom)
    
    MySplashRandom = math.mod(SplashRandom, 6) + 1
    Print("MySplashRandom ", MySplashRandom)

end

function Camera_Path_Stopped()
    if CameraFly == 1 then
        StartTimer("CreateTriggers", 2000)
--        StartTimer("TimedUpdate", 2000)
        SendMessage("Commentary.Clear")
        SendMessage("EFMV.End")
        CameraFly = 0
        CancelTimer(CamLoop)
        GameOn = 1
        StartFirstTurn()
    end
    
    if Camdone2 == 1 then
        Camdone2 = 0
        if MiniBreak == 1 then
            CheckForSpawnCPU()
        end
        CancelTimer(CamLoop1)
        CancelTimer(CamLoop2)
        SendMessage("Commentary.Clear")
        MiniBreak = 0
        GameOn = 1
        ResumeALL()
        CheckOneTeamVictory()
        CamLoop1 = 0
        CamLoop2 = 0
    end
end

function CameraFinished()

    StartTimer("CreateTriggers", 2000)
--    StartTimer("TimedUpdate", 2000)
    SendMessage("EFMV.End")
    CameraFly = 0
    GameOn = 1
    StartFirstTurn()
end

function Line1()
    SetData("CommentaryPanel.Comment", "Miss.Pegasus.brief1")
    SendMessage("CommentaryPanel.ScriptText")

    SetData("Camera.Path.Knots.Position", "Line1Cam,Line1Cam2")
    SetData("Camera.Path.Knots.LookAt", "Line1Look")
    SetData("Camera.Path.Steps.Position",600)
    SetData("Camera.Path.Steps.LookAt",600) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Line2", 4000)
end

function Line2()
    SetData("CommentaryPanel.Comment", "Miss.Pegasus.brief2")
    SendMessage("CommentaryPanel.ScriptText")

    SetData("Camera.Path.Knots.Position", "Line2Cam,Line2Cam2")
    SetData("Camera.Path.Knots.LookAt", "Line2Look")
    SetData("Camera.Path.Steps.Position",600)
    SetData("Camera.Path.Steps.LookAt",600) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Line3", 4000)
end

function Line3()
    --bridge
    SetData("CommentaryPanel.Comment", "Miss.Pegasus.brief3")
    SendMessage("CommentaryPanel.ScriptText")
    
    SendIntMessage("Worm.ResetAnim", 7)
    SetData("Worm.ScriptAnim", "Taunt1")
    SendIntMessage("Worm.QueueAnim", 7)
    SetData("Camera.Path.Knots.Position", "Line3Cam,Line3Cam2")
    SetData("Camera.Path.Knots.LookAt", "Line3Look")
    SetData("Camera.Path.Steps.Position",350)
    SetData("Camera.Path.Steps.LookAt",350) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Line4", 3000)
end

function Line4()
    --gun
    SetData("CommentaryPanel.Comment", "Miss.Pegasus.brief4")
    SendMessage("CommentaryPanel.ScriptText")
    
    SendIntMessage("Worm.ResetAnim", 6)
    SetData("Worm.ScriptAnim", "Yawn")
    SendIntMessage("Worm.QueueAnim", 6)
    SetData("Camera.Path.Knots.Position", "Line4Cam,Line4Cam2")
    SetData("Camera.Path.Knots.LookAt", "Line4Look")
    SetData("Camera.Path.Steps.Position",400)
    SetData("Camera.Path.Steps.LookAt",400) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Line5", 3000)
end

function Line5()
    --boat
    SetData("CommentaryPanel.Comment", "Miss.Pegasus.brief5")
    SendMessage("CommentaryPanel.ScriptText")
    
    SendIntMessage("Worm.ResetAnim", 8)
    SetData("Worm.ScriptAnim", "Smile2")
    SendIntMessage("Worm.QueueAnim", 8)
    SetData("Camera.Path.Knots.Position", "Line5Cam,Line5Cam2")
    SetData("Camera.Path.Knots.LookAt", "Line5Look,Line5Look2")
    SetData("Camera.Path.Steps.Position",400)
    SetData("Camera.Path.Steps.LookAt",400) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Line6", 2000)
end

function Line6()
    --building
    SendMessage("Commentary.Clear")
    
    SetData("CommentaryPanel.Comment", "Miss.Pegasus.brief6")
    SendMessage("CommentaryPanel.ScriptText")
    
    SendIntMessage("Worm.ResetAnim", 9)
    SetData("Worm.ScriptAnim", "Smug2")
    SendIntMessage("Worm.QueueAnim", 9)

    SetData("Camera.Path.Knots.Position", "Line6Cam,Line6Cam2")
    SetData("Camera.Path.Knots.LookAt", "Line6Look,Line6Look2")
    SetData("Camera.Path.Steps.Position",300)
    SetData("Camera.Path.Steps.LookAt",300) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Line7", 3000)
end

function Line7()
    SetData("CommentaryPanel.Comment", "Miss.Pegasus.brief7")
    SendMessage("CommentaryPanel.ScriptText")

    SetData("Camera.Path.Knots.Position", "Line7Cam,Line7Cam2")
    SetData("Camera.Path.Knots.LookAt", "Line7Look,Line7Look2")
    SetData("Camera.Path.Steps.Position",500)
    SetData("Camera.Path.Steps.LookAt",500) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Line8", 4500)
end

function Line8()
    SetData("CommentaryPanel.Comment", "Miss.Pegasus.brief8")
    SetData("CommentaryPanel.Delay",3000)
    SendMessage("CommentaryPanel.TimedText")
    SetData("Camera.Path.Knots.Position", "Line8Cam,Line8Cam2")
    SetData("Camera.Path.Knots.LookAt", "Line8Look")
    SetData("Camera.Path.Steps.Position",500)
    SetData("Camera.Path.Steps.LookAt",500) 
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("Line9", 4000)
end

function Line9()
    SetData("CommentaryPanel.Comment", "Miss.Pegasus.brief9")
    SetData("CommentaryPanel.Delay",3000)
    SendMessage("CommentaryPanel.TimedText")
    SendIntMessage("Worm.ResetAnim", 3)
    SetData("Worm.ScriptAnim", "Angry")
    SendIntMessage("Worm.QueueAnim", 3)
    SetData("Camera.Path.Knots.Position", "Line9Cam")
    SetData("Camera.Path.Knots.LookAt", "Line9Look")
    SendMessage("Camera.Path.Start")
    CamLoop = StartTimer("CameraFinished", 3500)
end

function StartTurn()
    done_once_per_turn_functions = false
    SendMessage("Timer.StartHotSeatTimer")
    SendMessage("GameLogic.ActivateNextWorm")
    SendMessage("Weapon.Create")
    SetWind()
    SendMessage("GameLogic.Turn.Started")
    TurnStarted()
    RunAILogic()
end




--////////////////////////////////////////////////////////////////
--//            Trigger Logic                                   //
--////////////////////////////////////////////////////////////////


function Trigger_Collected()
    CPUInGunArea = 0
    CPUInBridge = 0
    CPUInBoatArea = 0
    CPUInBuilding = 0
    PlayerInGunArea = 0
    PlayerInBridge = 0
    PlayerInBoatArea = 0
    PlayerInBuilding = 0
    InTheAreaText = 0
    
    
    TrigIndex = GetData("Trigger.Index")
    SendIntMessage("GameLogic.DestroyTrigger", TrigIndex)
    
    if TrigIndex == nCPUBuilding then
        nCPUControlled = nCPUControlled + 1
        CPUInBuilding = 1

    elseif TrigIndex == nCPUBridge then
        nCPUControlled = nCPUControlled + 1
        CPUInBridge = 1

    elseif TrigIndex == nCPUBoatArea then
        nCPUControlled = nCPUControlled + 1
        CPUInBoatArea = 1

    elseif TrigIndex == nCPUGunArea then
        nCPUControlled = nCPUControlled + 1
        CPUInGunArea = 1

    elseif TrigIndex == 2 then
        nPlayerControlled = nPlayerControlled + 1
        PlayerInBuilding = 1 
        if CPUInBuilding == 0 then
            ControlIsOurs = 1
        end
        
    elseif TrigIndex == 4 then
        nPlayerControlled = nPlayerControlled + 1
        PlayerInBridge = 1
        if CPUInBridge == 0 then
            ControlIsOurs = 2
        end
        
    elseif TrigIndex == 6 then
        nPlayerControlled = nPlayerControlled + 1
        PlayerInGunArea = 1
        if CPUInGunArea == 0 then
            ControlIsOurs = 3
        end
        
    elseif TrigIndex == 8 then
        nPlayerControlled = nPlayerControlled + 1
        PlayerInBoatArea = 1
        if CPUInBoatArea == 0 then
            ControlIsOurs = 4
        end
    end
    
--    if GameOn == 1 then
--        AnnounceTrigger()
--    end
    
    
    --takes care of human triggers
--    FlareControl()
end


function AnnounceTrigger()

    SendMessage("Commentary.Clear")

    TrigCollector = GetData("Trigger.Collector")
    CurrentWorm = GetData("ActiveWormIndex")
    
    TurnTimeRemaining = GetData("TurnTimeRemaining")
    
    if TurnTimeRemaining > 10000 then
        if TrigCollector == CurrentWorm then
            CurrentTeam = GetData("CurrentTeamIndex")
                
            if CurrentTeam == 0 then
                SetData("CommentaryPanel.Comment", "Pegasus.7")
            else
                SetData("CommentaryPanel.Comment", "Pegasus.8")
            end
            
            SetData("CommentaryPanel.Delay",4000)
            SendMessage("CommentaryPanel.TimedText")   
        end
    end


end


--////////////////////////////////////////////////////////////////
--//            Flare Logic                                     //
--////////////////////////////////////////////////////////////////

function FlareControl()

    if CPUInBridge == 0 and PlayerInBridge == 1 then  
        if FlareOffBridge == 0 then
            SetData("Particle.DetailObject", "FBridgePart")
            SetData("Particle.Name", "Part_FlareSmoke_Red")
            SendMessage("Particle.NewEmitter")
            FBridge = GetData("Particle.Handle")
            FlareOffBridge = 1
        end
    else
        SendIntMessage("Particle.DeleteEmitter",FBridge)
    end
  
  
    if CPUInGunArea == 0 and PlayerInGunArea == 1 then
        if FlareOffGun == 0 then
            SendIntMessage("Particle.DeleteEmitter", FGun)
        
            SetData("Particle.DetailObject", "FGunPart")
            SetData("Particle.Name", "Part_FlareSmoke_Red")
            SendMessage("Particle.NewEmitter")
            FGun = GetData("Particle.Handle")
            FlareOffGun = 1
        end
    else
        SendIntMessage("Particle.DeleteEmitter", FGun)
    end

    
    if CPUInBoatArea == 0 and PlayerInBoatArea == 1 then
        if FlareOffBoat == 0 then
            SendIntMessage("Particle.DeleteEmitter", FBoat)
            
            SetData("Particle.DetailObject", "FBoatPart")
            SetData("Particle.Name", "Part_FlareSmoke_Red")
            SendMessage("Particle.NewEmitter")
            FBoat = GetData("Particle.Handle")
            FlareOffBoatArea = 1
        end
    else
        SendIntMessage("Particle.DeleteEmitter", FBoat)
    end
 
 
    if CPUInBuilding == 0 and PlayerInBuilding == 1 then
        if FlareOffBuilding == 0 then 
            SendIntMessage("Particle.DeleteEmitter", FBuilding)
            
            SetData("Particle.DetailObject", "FBuildingPart")
            SetData("Particle.Name", "Part_FlareSmoke_Red")
            SendMessage("Particle.NewEmitter")
            FBuilding = GetData("Particle.Handle")
            FlareOffBuilding = 1
        end
    else
        SendIntMessage("Particle.DeleteEmitter", FBuilding)
    end    
    
end

--function Trigger_Collected()
--    TrigIndex = GetData("Trigger.Index")
--    SendIntMessage("GameLogic.DestroyTrigger", TrigIndex)
--    if TrigIndex == nCPUBuilding
--        or TrigIndex == nCPUBridge
--        or TrigIndex == nCPUGunArea
--        or TrigIndex == nCPUBoatArea then
--            nCPUControlled = nCPUControlled + 1
--    else
--        -- its a player trigger
--        nPlayerControlled = nPlayerControlled + 1
--        --bm1
--        if TrigIndex == 2 and CPUOnBuilding == 0 then
--            FlareBuilding = 1
--            FlareUpdate()
--        end
--    end
--end

--function TimedUpdate()
function CheckConditions()

    DeleteTriggers()
    CreateTriggers()

    if nCPUControlled == 0 and nPlayerControlled == 4 then
        -- here make sure the round timer is RESUMED
--        SendMessage("GameLogic.RoundTime.Resume")
        TextControl = TextControl + 1
        EnemyTextControl = 0
        StateOfText()
        PlayerOwnsArea = 1
        TakenControl = 1
        ControlSwitch = 0  
    elseif nCPUControlled > 0 then
        SendMessage("GameLogic.RoundTime.Pause")
        EnemyTextControl = EnemyTextControl + 1
        CPUStateOfText()
        ControlSwitch = 1
    elseif nPlayerControlled < 4 then    
        SendMessage("GameLogic.RoundTime.Pause")
        ControlSwitch = 1
    elseif nCPUControlled == 0 and nPlayerControlled == 0 then
        SendMessage("GameLogic.RoundTime.Pause")
        ControlSwitch = 1
    end
    
    
    if ControlSwitch == 1 then
        if PlayerOwnsArea == 1 then
            -- sets variable to something that isn't recognised anywhere in the script
            TextControl = 0
            SendMessage("Commentary.Clear")
            SetData("CommentaryPanel.Comment", "Pegasus.9")
            SendMessage("CommentaryPanel.ScriptText")
            SetData("CommentaryPanel.Comment", "Pegasus.10")
            SendMessage("CommentaryPanel.ScriptText")
            SendMessage("GameLogic.RoundTime.Pause")
            
            PlayerOwnsArea = 0
        else
        
        
        end
    end

    ControlSwitch = 0    
    --PlayerOwnsArea = 0
--    DeleteTriggers()
--    CreateTriggers()
--        CreateTimer()

     
end

function StateOfText()
    if TextControl == 1 then
        SendMessage("Commentary.Clear")
        SetData("CommentaryPanel.Comment", "Pegasus.5")
        SendMessage("CommentaryPanel.ScriptText")
        TextControl = 2
        EnemyTextControl = 0
    end
end

function CPUStateOfText()
    if EnemyTextControl == 1 then
        SendMessage("Commentary.Clear")
        SetData("CommentaryPanel.Comment", "Pegasus.8")
        SendMessage("CommentaryPanel.ScriptText")
        EnemyTextControl = 2
        TextControl = 0
    end
end

function DeleteTriggers()
    SendIntMessage("GameLogic.DestroyTrigger", 1)
    SendIntMessage("GameLogic.DestroyTrigger", 2)
    SendIntMessage("GameLogic.DestroyTrigger", 3)
    SendIntMessage("GameLogic.DestroyTrigger", 4)
    SendIntMessage("GameLogic.DestroyTrigger", 5)
    SendIntMessage("GameLogic.DestroyTrigger", 6)
    SendIntMessage("GameLogic.DestroyTrigger", 7)
    SendIntMessage("GameLogic.DestroyTrigger", 8)
end

--function CreateTimer()
--    Timer1 = StartTimer("TimedUpdate", 1000)
--end

function CreateTriggers()
-- CPU Building Area (Index 1)
    SetData("Trigger.Spawn", "CPUBuildingArea")
    SetData("Trigger.Radius", 55)
    SetData("Trigger.Index", 1)
    SetData("Trigger.TeamCollect", 1)
    SetData("Trigger.Visibility", 0)
    SendMessage("GameLogic.CreateTrigger")
    
-- PLAYER Building Area (Index 2)
    SetData("Trigger.Spawn", "BuildingArea")
    SetData("Trigger.Radius", 55)
    SetData("Trigger.Index", 2)
    SetData("Trigger.TeamCollect", 0)
    SendMessage("GameLogic.CreateTrigger")

-- CPU Bridge Area (Index 3)
    SetData("Trigger.Spawn", "CPUBridgeArea")
    SetData("Trigger.Radius", 55)
    SetData("Trigger.Index", 3)
    SetData("Trigger.TeamCollect", 1)
    SendMessage("GameLogic.CreateTrigger")
    
-- PLAYER Bridge Area (Index 4)
    SetData("Trigger.Spawn", "BridgeArea")
    SetData("Trigger.Radius", 55)
    SetData("Trigger.Index", 4)
    SetData("Trigger.TeamCollect", 0)
    SendMessage("GameLogic.CreateTrigger")
    
-- CPU Gun Area (Index 5)
    SetData("Trigger.Spawn", "CPUGunArea")
    SetData("Trigger.Radius", 55)
    SetData("Trigger.Index", 5)
    SetData("Trigger.TeamCollect", 1)
    SendMessage("GameLogic.CreateTrigger")

-- PLAYER Gun Area (Index 6)
    SetData("Trigger.Spawn", "GunArea")
    SetData("Trigger.Radius", 55)
    SetData("Trigger.Index", 6)
    SetData("Trigger.TeamCollect", 0)
    SendMessage("GameLogic.CreateTrigger")

-- CPU Boat Area (Index 7)
    SetData("Trigger.Spawn", "CPUBoatArea")
    SetData("Trigger.Radius", 55)
    SetData("Trigger.Index", 7)
    SetData("Trigger.TeamCollect", 1)
    SendMessage("GameLogic.CreateTrigger")

-- PLAYER Boat Area (Index 8)
    SetData("Trigger.Spawn", "BoatArea")
    SetData("Trigger.Radius", 55)
    SetData("Trigger.Index", 8)
    SetData("Trigger.TeamCollect", 0)
    SendMessage("GameLogic.CreateTrigger")
    

    
end

function Worm_Died()
    deadworm = GetData("DeadWorm.Id")
    if deadworm == 0 or deadworm == 1 or deadworm == 2 or deadworm == 3 or deadworm == 4 or deadworm == 5 then
        DeadHuman = DeadHuman + 1
        if DeadHuman == 3 then
            if Switch2 == 0 then
                SendMessage("Commentary.Clear")
                SetData("CommentaryPanel.Comment", "Miss.Apple.failed")
                SendMessage("CommentaryPanel.ScriptText")
                endmissionfail()    CurrentTeam = GetData("CurrentTeamIndex")
                Switch2 = 1
            end
        end
    elseif deadworm == 6 then
        CPUOnGunArea = 0
        DeadCPU = DeadCPU + 1
    elseif deadworm == 7 then
        CPUOnBridge = 0
        DeadCPU = DeadCPU + 1
    elseif deadworm == 8 then
        CPUOnBoatArea = 0
        DeadCPU = DeadCPU + 1
    elseif deadworm == 9 then
        CPUOnBuilding = 0
        DeadCPU = DeadCPU + 1
    end
end

function GetRandomNumber()
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Uint")
    MyRandomNumber = math.mod(RandomNumber, 2) + 1
end

function SpawnNewCPU()

    if CPUOnGunArea == 0 then
        if CPUTextState == 0 then
            CPUTextState = 1
        end
        GetRandomNumber()
        lock, worm = EditContainer("Worm.Data06")
        worm.Active = true
        worm.Name = "Grunt"
        worm.Energy = 100
        worm.DamagePending = 0
        worm.WeaponFuse = 3
        worm.WeaponIsBounceMax = false
        worm.TeamIndex = 1
        worm.SfxBankName = "War General"
        --herelio
        worm.IsParachuteSpawn = true
        CPUOnGunArea = 1
        if MyRandomNumber == 1 then
            worm.Spawn = "CPUSpawn2"
            CloseContainer(lock)
            SendIntMessage("Worm.Respawn", 6)
        else
            worm.Spawn = "CPUSpawn2b"
            CloseContainer(lock)
            SendIntMessage("Worm.Respawn", 6)
        end
        CopyContainer("AIParams.CPU3", "AIParams.Worm06")
        lock, AIParams = EditContainer("AIParams.Worm06") 
        AIParams.AttractorDetailObject = "AI_Gun"
        CloseContainer(lock)
    end
    
    if CPUOnBridge == 0 then
        if CPUTextState == 0 then
            CPUTextState = 1
        end
        GetRandomNumber()
        lock, worm = EditContainer("Worm.Data07")
        worm.Active = true
        worm.Name = "Private"
        worm.Energy = 100
        worm.WeaponFuse = 3
        worm.DamagePending = 0
        worm.WeaponIsBounceMax = false
        worm.TeamIndex = 1
        worm.SfxBankName = "War General"
        CPUOnBridge = 1
        if MyRandomNumber == 1 then
            worm.Spawn = "CPUSpawn3"
            CloseContainer(lock)
            SendIntMessage("Worm.Respawn", 7)
        else
            worm.Spawn = "CPUSpawn3b"
            CloseContainer(lock)
            SendIntMessage("Worm.Respawn", 7)
        end
        CopyContainer("AIParams.CPU3", "AIParams.Worm07")
        lock, AIParams = EditContainer("AIParams.Worm07") 
        AIParams.AttractorDetailObject = "AI_Bridge"
        CloseContainer(lock)
    end
    
    if CPUOnBoatArea == 0 then
        if CPUTextState == 0 then
            CPUTextState = 1
        end
        GetRandomNumber()
        lock, worm = EditContainer("Worm.Data08")
        worm.Active = true
        worm.Name = "Lieutenant"
        worm.Energy = 100
        worm.WeaponFuse = 3
        worm.WeaponIsBounceMax = false
        worm.DamagePending = 0
        worm.TeamIndex = 1
        worm.SfxBankName = "War General"
        CPUOnBoatArea = 1
        if MyRandomNumber == 1 then
            worm.Spawn = "CPUSpawn1"
            CloseContainer(lock)
            SendIntMessage("Worm.Respawn", 8)
        else
            worm.Spawn = "CPUSpawn1b"
            CloseContainer(lock)
            SendIntMessage("Worm.Respawn", 8)
        end
        CopyContainer("AIParams.CPU3", "AIParams.Worm08")
        lock, AIParams = EditContainer("AIParams.Worm08") 
        AIParams.AttractorDetailObject = "AI_Boat"
        CloseContainer(lock)
    end
    
    if CPUOnBuilding == 0 then
        if CPUTextState == 0 then
            CPUTextState = 1
        end
        GetRandomNumber()
        lock, worm = EditContainer("Worm.Data09")
        worm.Active = true
        worm.Name = "Sarge"
        worm.Energy = 100
        worm.WeaponFuse = 3
        worm.WeaponIsBounceMax = false
        worm.DamagePending = 0
        worm.TeamIndex = 1
        worm.SfxBankName = "War General"
        CPUOnBuilding = 1
        if MyRandomNumber == 1 then
            worm.Spawn = "CPUSpawn4"
            CloseContainer(lock)
            SendIntMessage("Worm.Respawn", 9)
        else
            worm.Spawn = "CPUSpawn4b"
            CloseContainer(lock)
            SendIntMessage("Worm.Respawn", 9)
        end
        CopyContainer("AIParams.CPU3", "AIParams.Worm09")
        lock, AIParams = EditContainer("AIParams.Worm09") 
        AIParams.AttractorDetailObject = "AI_Building"
        CloseContainer(lock)
    end
    
    CPUTextControl()
end

function CPUTextControl()
    if CPUTextState == 1 then
        SetData("CommentaryPanel.Comment", "Pegasus.11")
        SendMessage("CommentaryPanel.ScriptText")
        CPUTextState = 0
    end
end

function TurnStarted()
    Team = GetData("CurrentTeamIndex")
    if Team == 0 then
        SendMessage("WormSelect.OptionSelected")
    end
end

function DoOncePerTurnFunctions()
    if TakenControl == 1 then
        SpawnHealthCrates()
    end

end

function TurnEnded()

    CheckConditions()

    Team = GetData("CurrentTeamIndex")

    --if TakenControl == 1 then
    --    SpawnHealthCrates()
    --end

    if PlayerOwnsArea == 1 and Team == 1 then
    --if TestCock == 1 then
        TurnsRemain = TurnsRemain - 1
        --if TurnsRemain == 9 then
        --    SetData("CommentaryPanel.Comment", "Miss.count9")
        --    SendMessage("CommentaryPanel.ScriptText")
        --    RoundTimeRemaining = GetData("RoundTimeRemaining")
        --    SetData("RoundTimeRemaining", RoundTimeRemaining-60000)
        --elseif TurnsRemain == 8 then
        --    SetData("CommentaryPanel.Comment", "Miss.count8")
        --    SendMessage("CommentaryPanel.ScriptText")
        -- RoundTimeRemaining = GetData("RoundTimeRemaining")
        --    SetData("RoundTimeRemaining", RoundTimeRemaining-60000)
        --elseif TurnsRemain == 7 then
        --    SetData("CommentaryPanel.Comment", "Miss.count7")
        --    SendMessage("CommentaryPanel.ScriptText")
        --    RoundTimeRemaining = GetData("RoundTimeRemaining")
        --    SetData("RoundTimeRemaining", RoundTimeRemaining-60000)
        --elseif TurnsRemain == 6 then
        --    SetData("CommentaryPanel.Comment", "Miss.count6")
        --    SendMessage("CommentaryPanel.ScriptText")
        --    RoundTimeRemaining = GetData("RoundTimeRemaining")
        --   SetData("RoundTimeRemaining", RoundTimeRemaining-60000)
--        if TurnsRemain == 5 then
--            SetData("CommentaryPanel.Comment", "Miss.count5")
--            SendMessage("CommentaryPanel.ScriptText")
--            RoundTimeRemaining = GetData("RoundTimeRemaining")
--            SetData("RoundTimeRemaining", RoundTimeRemaining-60000)
        if TurnsRemain == 4 then
--            SetData("CommentaryPanel.Comment", "Miss.count4")
--            SendMessage("CommentaryPanel.ScriptText")
            RoundTimeRemaining = GetData("RoundTimeRemaining")
            SetData("RoundTimeRemaining", RoundTimeRemaining-60000)
        elseif TurnsRemain == 3 then
--            SetData("CommentaryPanel.Comment", "Miss.count3")
--            SendMessage("CommentaryPanel.ScriptText")
            RoundTimeRemaining = GetData("RoundTimeRemaining")
            SetData("RoundTimeRemaining", RoundTimeRemaining-60000)
        elseif TurnsRemain == 2 then
--            SetData("CommentaryPanel.Comment", "Miss.count2")
--            SendMessage("CommentaryPanel.ScriptText")
            RoundTimeRemaining = GetData("RoundTimeRemaining")
            SetData("RoundTimeRemaining", RoundTimeRemaining-60000)
        elseif TurnsRemain == 1 then
--            SetData("CommentaryPanel.Comment", "Miss.count1")
--            SendMessage("CommentaryPanel.ScriptText")
            RoundTimeRemaining = GetData("RoundTimeRemaining")
            SetData("RoundTimeRemaining", RoundTimeRemaining-60000)
        elseif TurnsRemain == 0 then
            RoundTimeRemaining = GetData("RoundTimeRemaining")
            SetData("RoundTimeRemaining", RoundTimeRemaining-60000)
            SendMessage("GameLogic.PauseGame")
            EFMVSequence = 0
            MiniBreak = 1
            SetData("Camera.Path.IgnoreInput", 1)
            SendMessage("EFMV.Start")
            FinalSequence1()
        end
    end
    
    


    if EFMVSequence == 1 then
        if Team == 1 then
            if nCPUControlled == 0 and nPlayerControlled == 4 then
                PauseALL()
                Start1 = 1
                MiniBreak = 1
                SendMessage("EFMV.Start")
                SendMessage("Commentary.Clear")
                StartTimer("Locations1", 0200)
            end
        end
    end
    
    if MiniBreak == 0 then
        CheckForSpawnCPU()
        CheckOneTeamVictory()
    end

    nCPUControlled = 0
    nPlayerControlled = 0
    
end

function CheckForSpawnCPU()
    if DeadCPU < 4 or DeadCPU > 4 then
        SpawnNewCPU()
    elseif DeadCPU == 4 then
        DeadCPU = 5
    end
end


function FinalSequence1()
    --SetData("CommentaryPanel.Comment", "Chall.GTAttack.Finished")
    --SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "MidBridgeCam,MidBridgeCam2")
    SetData("Camera.Path.Knots.LookAt", "MidBridgeLook")
    SetData("Camera.Path.Steps.Position",600)
    SetData("Camera.Path.Steps.LookAt",600)
    SetData("Camera.Path.IgnoreInput", 1)
    SendMessage("Camera.Path.Start")
    StartTimer("FinalSequence2", 3000)
end

function FinalSequence2()
    SendMessage("Commentary.Clear")
    SetData("CommentaryPanel.Comment", "Miss.generic.success")
    SetData("CommentaryPanel.Delay",6000)
    SendMessage("CommentaryPanel.TimedText")
    SetData("Camera.Path.Knots.Position", "MidBuildCam,MidBuildCam2")
    SetData("Camera.Path.Knots.LookAt", "MidBuildLook")
    SetData("Camera.Path.Steps.Position",600)
    SetData("Camera.Path.Steps.LookAt",600)
    SetData("Camera.Path.IgnoreInput", 1)
    SendMessage("Camera.Path.Start")
    StartTimer("FinalSequence3", 3000)
end

function FinalSequence3()
    SetData("Camera.Path.Knots.Position", "MidGunAreaCam,MidGunAreaCam2")
    SetData("Camera.Path.Knots.LookAt", "MidGunAreaLook")
    SetData("Camera.Path.Steps.Position",600)
    SetData("Camera.Path.Steps.LookAt",600)
    SetData("Camera.Path.IgnoreInput", 1)
    SendMessage("Camera.Path.Start")
    StartTimer("FinalSequence4", 3000)
end

function FinalSequence4()
    SetData("Camera.Path.Knots.Position", "MidBoatCam,MidBoatCam2")
    SetData("Camera.Path.Knots.LookAt", "MidBoatLook")
    SetData("Camera.Path.Steps.Position",600)
    SetData("Camera.Path.Steps.LookAt",600)
    SetData("Camera.Path.IgnoreInput", 1)
    SendMessage("Camera.Path.Start")
    MiniBreak = 0
    StartTimer("endmissionsuccess", 3000)
end



function WhichArea()

    if ControlIsOurs == 1 then
    
    elseif ControlIsOurs == 1 then
        SetData("CommentaryPanel.Comment", "Miss.Pegasus.brief6")
        SendMessage("CommentaryPanel.ScriptText")
    elseif ControlIsOurs == 2 then
        SetData("CommentaryPanel.Comment", "Miss.Pegasus.brief3")
        SendMessage("CommentaryPanel.ScriptText")
    elseif ControlIsOurs == 3 then
        SetData("CommentaryPanel.Comment", "Miss.Pegasus.brief4")
        SendMessage("CommentaryPanel.ScriptText")
    elseif ControlIsOurs == 4 then
        SetData("CommentaryPanel.Comment", "Miss.Pegasus.brief5")
        SendMessage("CommentaryPanel.ScriptText")
    end   
end


function PauseALL()
    SetData("Camera.Path.IgnoreInput", 1)
    SendStringMessage("Camera.Disable", "Track")
--    SendMessage("GameLogic.PauseGame")
--    CancelTimer("Timer1")
    
    --pause game timers perhaps?
end

function ResumeALL()
    SendMessage("EFMV.End")
    SetData("Camera.Path.IgnoreInput", 0)
    SendStringMessage("Camera.Enable", "Track")
--    SendMessage("GameLogic.ResumeGame")
--    CreateTimer()
    DeleteTriggers()
    CreateTriggers()
    --resume game timers perhaps?
--    SpawnNewCPU()
end

function Locations1()
    --SetData("CommentaryPanel.Comment", "Chall.GTAttack.Finished")
    --SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.IgnoreInput", 0)
    SetData("Camera.Path.Knots.Position", "MidBridgeCam,MidBridgeCam2")
    SetData("Camera.Path.Knots.LookAt", "MidBridgeLook")
    SetData("Camera.Path.Steps.Position",600)
    SetData("Camera.Path.Steps.LookAt",600)
    SendMessage("Camera.Path.Start")
    CamLoop1 = StartTimer("Locations2", 3000)
    Camdone2 = 1
end

function Locations2()
    SetData("Camera.Path.Knots.Position", "MidBuildCam,MidBuildCam2")
    SetData("Camera.Path.Knots.LookAt", "MidBuildLook")
    SetData("Camera.Path.Steps.Position",600)
    SetData("Camera.Path.Steps.LookAt",600)
    SendMessage("Camera.Path.Start")
    CamLoop1 = StartTimer("Locations3", 3000)
end

function Locations3()
    SetData("CommentaryPanel.Comment", "Pegasus.10")
    SendMessage("CommentaryPanel.ScriptText")
    SetData("Camera.Path.Knots.Position", "MidGunAreaCam,MidGunAreaCam2")
    SetData("Camera.Path.Knots.LookAt", "MidGunAreaLook")
    SetData("Camera.Path.Steps.Position",600)
    SetData("Camera.Path.Steps.LookAt",600)
    SendMessage("Camera.Path.Start")
    CamLoop1 = StartTimer("Locations4", 3000)
end

function Locations4()
    SetData("Camera.Path.Knots.Position", "MidBoatCam,MidBoatCam2")
    SetData("Camera.Path.Knots.LookAt", "MidBoatLook")
    SetData("Camera.Path.Steps.Position",600)
    SetData("Camera.Path.Steps.LookAt",600)
    SendMessage("Camera.Path.Start")
    MiniBreak = 0
    CheckForSpawnCPU()
    CamLoop1 = StartTimer("ResumeALL", 3000)
    CamLoop2 = StartTimer("CheckOneTeamVictory", 3000)
end

function MakeHealthRandomNumber()
    SendMessage("RandomNumber.Get")
    HealthRandom = GetData("RandomNumber.Uint")
    Print("HealthRandom ", HealthRandom)
        
    HealthRandomNumber = math.mod(HealthRandom, 4) + 1
    Print("HealthRandomNumber ", HealthRandomNumber)
end

function SpawnHealthCrates()
    MakeHealthRandomNumber()
    if HealthRandomNumber == 1 then
        if HealthGunArea == 0 then
            --SetData("CommentaryPanel.Comment", "Text.Health")
            --SendMessage("CommentaryPanel.ScriptText")
            SetData("Crate.Spawn", "HealthGunArea")
            SetData("Crate.Type", "Health")
            SetData("Crate.NumContents", 20)
            SetData("Crate.Index",101)
            SetData("Crate.GroundSnap", 0)
            SendMessage("GameLogic.CreateCrate")
            HealthGunArea = 1
        end
    elseif HealthRandomNumber == 2 then
        if HealthBridge == 0 then
            --SetData("CommentaryPanel.Comment", "Text.Health")
            --SendMessage("CommentaryPanel.ScriptText")
            SetData("Crate.Spawn", "HealthBridge")
            SetData("Crate.Type", "Health")
            SetData("Crate.NumContents", 20)
            SetData("Crate.Index",102)
            SetData("Crate.GroundSnap", 0)
            SendMessage("GameLogic.CreateCrate")
            HealthBridge = 1
        end
    elseif HealthRandomNumber == 3 then
        if HealthBoatArea == 0 then
            --SetData("CommentaryPanel.Comment", "Text.Health")
            --SendMessage("CommentaryPanel.ScriptText")
            SetData("Crate.Spawn", "HealthBoatArea")
            SetData("Crate.Type", "Health")
            SetData("Crate.NumContents", 20)
            SetData("Crate.Index",103)
            SetData("Crate.GroundSnap", 0)
            SendMessage("GameLogic.CreateCrate")
            HealthBoatArea = 1
        end
    elseif HealthRandomNumber == 4 then
        if HealthBuilding == 0 then
            --SetData("CommentaryPanel.Comment", "Text.Health")
            --SendMessage("CommentaryPanel.ScriptText")
            SetData("Crate.Spawn", "HealthBuilding")
            SetData("Crate.Type", "Health")
            SetData("Crate.NumContents", 20)
            SetData("Crate.Index",104)
            SetData("Crate.GroundSnap", 0)
            SendMessage("GameLogic.CreateCrate")
            HealthBuilding = 1
        end
    end
end

function Crate_Collected()
    CrateNumber = GetData("Crate.Index")
    if CrateNumber == 101 then
        HealthGunArea = 0
    elseif CrateNumber == 102 then
        HealthBridge = 0
    elseif CrateNumber == 103 then
        HealthBoatArea = 0
    elseif CrateNumber == 104 then
        HealthBuilding = 0
    end
end

function CheckOneTeamVictory()
   SendMessage("WormManager.GetActiveTeamCount")
   TeamCount = GetData("TeamCount")
   if TeamCount == 0 then
        if Switch2 == 0 then
            endmissionfail()
            Switch2 = 1
        end
   elseif MiniBreak == 1 then
       
   else
       StartTurn()
   end

end

function endmissionsuccess()
    
    Result()

end



--///////////////////////////////////////////////////////////////
--//            Check for which award you get                  //
--///////////////////////////////////////////////////////////////


function Result()


    SetData("Camera.Path.IgnoreInput", 1)
    
    timetook = GetData("ElapsedRoundTime")
    
    if timetook < bronzetime then
        Movie = 1
        Key,Lock = EditContainer("L.C.JP3") --JetPack Challenge 3
        if Lock.Locked == true then
            Lock.Locked = false
            SetData("MCa.LockedName2","L.C.JP3")
        end
        CloseContainer(Key)
        
        if timetook < silvertime then
            Movie = 2
            
            if timetook < goldtime then
                Movie = 3

                Key,Lock = EditContainer("L.Sch.All") --April Fools wormapedia entry
                if Lock.Locked == true then
                    Lock.Locked = false
                    SetData("MCa.LockedName","L.Sch.All")
                end
                CloseContainer(Key)
            end
        end
    end
    
    
    if Movie == 1 then
        SetData("MCa.LastGameTime", 1)
        SetData("GameOver.AwardMovie","bronze")
    elseif Movie == 2 then
        SetData("MCa.LastGameTime", 2)
        SetData("GameOver.AwardMovie","silver")
    elseif Movie == 3 then
        SetData("MCa.LastGameTime", 3)
        SetData("GameOver.AwardMovie","gold")
    end
    
    SendMessage("GameLogic.Mission.Success")

end



function endmissionfail()
    SetData("CommentaryPanel.Comment", "Miss.generic.fail")
    SendMessage("CommentaryPanel.ScriptText")
    SendMessage("GameLogic.Mission.Failure")
end

--function Timer_GameTimedOut()
--    endmissionsuccess()
--end

function SetupWormsAndTeams()
    GM = QueryContainer("GM.GameInitData")
    lock, team = EditContainer("Team.Data00") 
    team.Active = true
    team.FlagGfxName = GM.T1_Flag
    team.Name = GM.T1_Name
    team.GraveIndex = GM.T1_Grave
    team.TeamColour = 0
    CloseContainer(lock)
    
    lock, team = EditContainer("Team.Data01") 
    team.Active = true
    team.Name = "The Enemy"
    team.FlagGfxName = "96"
    team.TeamColour = 1
    team.IsAIControlled = true
    CloseContainer(lock)

    lock, worm = EditContainer("Worm.Data00") 
    worm.Active = true
    worm.Name = GM.T1_W1_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Energy = 100
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    worm.Spawn = "HumanWorm1"
    CloseContainer(lock)
    
    CopyContainer("Worm.Data00", "Worm.Data01")
    lock, worm = EditContainer("Worm.Data01")
    worm.Energy = 100
    worm.Name = GM.T1_W2_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "HumanWorm2"
    CloseContainer(lock)

    CopyContainer("Worm.Data00", "Worm.Data02")
    lock, worm = EditContainer("Worm.Data02")
    worm.Energy = 100
    worm.Name = GM.T1_W3_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "HumanWorm3"
    CloseContainer(lock)
    
    CopyContainer("Worm.Data00", "Worm.Data03")
    lock, worm = EditContainer("Worm.Data03")
    worm.Energy = 100
    worm.Name = GM.T1_W4_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "HumanWorm4"
    CloseContainer(lock)

    CopyContainer("Worm.Data00", "Worm.Data04")
    lock, worm = EditContainer("Worm.Data04")
    worm.Energy = 100
    worm.Name = GM.T1_W5_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "HumanWorm5"
    CloseContainer(lock)

    CopyContainer("Worm.Data00", "Worm.Data05")
    lock, worm = EditContainer("Worm.Data05")
    worm.Energy = 100
    worm.Name = GM.T1_W6_Name
    worm.SfxBankName = GM.T1_Speech
    worm.Spawn = "HumanWorm6"
    CloseContainer(lock)
    
    lock, worm = EditContainer("Worm.Data06")
    worm.Active = true
    worm.Name = "Riley"
    worm.Energy = 60
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 1
    worm.SfxBankName = "War General"
    worm.Spawn = "CPUWorm1"
    CloseContainer(lock)
    CopyContainer("AIParams.CPU3", "AIParams.Worm06")
    
    lock, AIParams = EditContainer("AIParams.Worm06") 
    AIParams.AttractorDetailObject = "AI_Gun"
    CloseContainer(lock)
    
    CopyContainer("Worm.Data06", "Worm.Data07")
    lock, worm = EditContainer("Worm.Data07")
    worm.Energy = 60
    worm.Name = "Soldier Boy"
    worm.TeamIndex = 1
    worm.Spawn = "CPUWorm2"
    CloseContainer(lock)
    CopyContainer("AIParams.CPU3", "AIParams.Worm07")
    lock, AIParams = EditContainer("AIParams.Worm07") 
    AIParams.AttractorDetailObject = "AI_Bridge"
    CloseContainer(lock)
    
    CopyContainer("Worm.Data06", "Worm.Data08")
    lock, worm = EditContainer("Worm.Data08")
    worm.Energy = 60
    worm.Name = "Camo"
    worm.TeamIndex = 1
    worm.Spawn = "CPUWorm3"
    CloseContainer(lock)
    CopyContainer("AIParams.CPU3", "AIParams.Worm08")
    lock, AIParams = EditContainer("AIParams.Worm08") 
    AIParams.AttractorDetailObject = "AI_Boat"
    CloseContainer(lock)
    
    CopyContainer("Worm.Data06", "Worm.Data09")
    lock, worm = EditContainer("Worm.Data09")
    worm.Energy = 60
    worm.Name = "Born To Kill"
    worm.TeamIndex = 1
    worm.Spawn = "CPUWorm4"
    CloseContainer(lock)
    CopyContainer("AIParams.CPU3", "AIParams.Worm09")
    lock, AIParams = EditContainer("AIParams.Worm09") 
    AIParams.AttractorDetailObject = "AI_Building"
    CloseContainer(lock)
    
    SendMessage("WormManager.Reinitialise")
end

function SetupInventories()
    lock, inventory = EditContainer("Inventory.Team00") 
    inventory.Bazooka = -1
    inventory.Grenade = -1
    inventory.ClusterGrenade = 3
    inventory.Airstrike = 1
    inventory.Landmine = 2
    inventory.Shotgun = 2
    inventory.Uzi = 2
    inventory.Prod = -1
    inventory.FirePunch = 2
    inventory.HomingMissile = 2
    inventory.Parachute = 3
    inventory.Teleport = 2
    inventory.NinjaRope = 2
    inventory.BaseballBat = 1
    inventory.Jetpack = 2
    inventory.ChangeWorm = -1
    inventory.SkipGo	= -1
    CloseContainer(lock)
    
    lock, inventory = EditContainer("Inventory.Team01") 
    inventory.Bazooka = -1
    inventory.Grenade = -1
    inventory.ClusterGrenade = 3
    inventory.Shotgun = 3
    inventory.Prod = -1
    inventory.FirePunch = -1
    inventory.Parachute = 2
    inventory.BaseballBat = -1
    inventory.Jetpack = 3
    inventory.SkipGo	= -1
    CloseContainer(lock)
end
