
-- Mission Basic setup 1v1 player

function Initialise()
    CurrentTurn = 0
-- Sets up mines and turn time
    SetData("Mine.DudProbabilty", 0.1)
    SetData("Mine.MinFuse", 1000)
    SetData("Mine.MaxFuse", 5000)

    SendMessage("GameLogic.PlaceObjects")
    SetupWormsAndTeams()
    SetupInventories()
    StartFirstTurn()
    
end


function RunAILogic()

	-- by default, call the AI to do a turn.
	SendMessage("AI.PerformDefaultAITurn");

	-- now we can ovverride the default for special cases.. based on our current AI turn.
	if CurrentTurn == 0 then
		SendStringMessage("CommentaryPanel.DebugText","Turn One AI Control")
		SendMessage("AI.ClearActions")
		SetData("AI.DataString", "kWeaponGrenade")
		SendMessage("AI.PerformSetWeaponAction")
		SetData("AI.DataString", "FireOne")
		SendMessage("AI.PerformFireAtTargetAction")
	elseif CurrentTurn == 1 then
		SendStringMessage("CommentaryPanel.DebugText","Turn Two AI Control")
		SendMessage("AI.ClearActions")
		SetData("AI.DataString", "FireOne")
		SendMessage("AI.PerformMoveAction")
		SetData("AI.DataString", "kWeaponGrenade")
		SendMessage("AI.PerformSetWeaponAction")
		SetData("AI.DataString", "FireTwo")
		SendMessage("AI.PerformFireAtTargetAction")
	elseif CurrentTurn == 2 then
		SendStringMessage("CommentaryPanel.DebugText","Turn Three AI Control")
		SendMessage("AI.ClearActions")
		SetData("AI.DataString", "MoveToTwo")
		SendMessage("AI.PerformMoveAction")
		SetData("AI.DataString", "kWeaponBazooka")
		SendMessage("AI.PerformSetWeaponAction")
		SetData("AI.DataString", "FireTwo")
		SendMessage("AI.PerformFireAtTargetAction")
	elseif CurrentTurn == 3 then
		SendStringMessage("CommentaryPanel.DebugText","Turn Four AI Control")
		SendMessage("AI.ClearActions")
		SetData("AI.DataString", "MoveToThree")
		SendMessage("AI.PerformMoveAction")
		SetData("AI.DataString", "kWeaponBazooka")
		SendMessage("AI.PerformSetWeaponAction")
		SetData("AI.DataString", "FireTwo")
		SendMessage("AI.PerformFireAtTargetAction")
		
	end	
	
	-- now actually cause the turn plan to be run
	SendMessage("AI.ExecuteActions")
	
	-- increment which AI turn we are on.
	CurrentTurn = CurrentTurn + 1
end



function SelectRandomWind()
-- First the speed
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Float")
    MaxWind = GetData("Wind.MaxSpeed")
-- The line below controls the strength in this case it will be no more than 6
    SetData("Wind.Speed", RandomNumber*MaxWind * 6 /10)
-- Now a direction
    SendMessage("RandomNumber.Get")
    RandomNumber = GetData("RandomNumber.Float")
    Direction = RandomNumber * 2 * 3.14
    SetData("Wind.Direction", Direction)   
end

function SetupWormsAndTeams()
-- Activate Team 0
    lock, team = EditContainer("Team.Data00") 
    team.Active = true
    team.Name = GetData("User.HumanTeamName")
    team.TeamColour = 0
-- team.IsAIControlled = true
    CloseContainer(lock) -- must close the container ASAP
-- Activate Team 1
    lock, team = EditContainer("Team.Data01") 
    team.Active = true
    team.Name = "The Darksiders"
    team.TeamColour = 1
 team.IsAIControlled = true
    CloseContainer(lock)
-- Worm 0, Team 0
    lock, worm = EditContainer("Worm.Data00") 
    worm.Active = true
    worm.Name = GetData ("User.HumanWorm1")
    worm.Energy = 100
    worm.WeaponFuse = 3
    worm.WeaponIsBounceMax = false
    worm.TeamIndex = 0
    worm.SfxBankName = "Pirate"
    worm.Spawn = "spawn1"
    CloseContainer(lock) 

-- Worm 4, Team 1
    CopyContainer("Worm.Data00", "Worm.Data04")
    lock, worm = EditContainer("Worm.Data04")
    worm.Energy = 80 
    worm.Name = "Agent Dennis"
    worm.TeamIndex = 1
    worm.SfxBankName = "Biggles"
    worm.Spawn = "spawn2"
    CloseContainer(lock)
    
   SendMessage("WormManager.Reinitialise")
end

function No()
-- Worm 1, Team 0
    CopyContainer("Worm.Data00", "Worm.Data01")
    lock, worm = EditContainer("Worm.Data01") 
    worm.Name = GetData ("User.HumanWorm2")
    worm.Spawn = "spawn"
    CloseContainer(lock)
-- Worm 2, Team 0
    CopyContainer("Worm.Data00", "Worm.Data02")
    lock, worm = EditContainer("Worm.Data02") 
    worm.Name = GetData ("User.HumanWorm3")
    worm.Spawn = "spawn"
    CloseContainer(lock)
-- Worm 3, Team 0
    CopyContainer("Worm.Data00", "Worm.Data03")
    lock, worm = EditContainer("Worm.Data03") 
    worm.Name = GetData ("User.HumanWorm4")
    worm.Spawn = "spawn"
    CloseContainer(lock)    
-- Worm 5, Team 1
    CopyContainer("Worm.Data04", "Worm.Data05")
    lock, worm = EditContainer("Worm.Data05")
    worm.Energy = 80  
    worm.Name = "Chesh"
    worm.Spawn = "spawn"
    CloseContainer(lock)
-- Worm 6, Team 1
    CopyContainer("Worm.Data04", "Worm.Data06")
    lock, worm = EditContainer("Worm.Data06")
    worm.Energy = 80  
    worm.Name = "Dunst"
    worm.Spawn = "spawn"
    CloseContainer(lock)
-- Worm 7, Team 1
    CopyContainer("Worm.Data04", "Worm.Data07")
    lock, worm = EditContainer("Worm.Data07")
    worm.Energy = 80  
    worm.Name = "Das Bruce"
    worm.Spawn = "spawn"
    CloseContainer(lock)
end

function SetupInventories()
-- sets up a default container and adds our selection to it
    lock, inventory = EditContainer("Inventory.Team.Default") 
    inventory.Bazooka = -1
    inventory.Grenade = -1
    inventory.ClusterGrenade = 5
    inventory.Airstrike = 2
    inventory.Dynamite = 2
    inventory.HolyHandGrenade = 2
    inventory.BananaBomb = 2
    inventory.Landmine = 3
    inventory.HomingMissile = -1
    inventory.HomingPidgeon = 1
    inventory.Sheep = 2
    inventory.SuperSheep = -1
    inventory.Parachute = 3
    inventory.Teleport = 2
    inventory.Jetpack = -1
    inventory.SkipGo = -1
    inventory.SuperBananaBomb = 2
    inventory.MadCow = -1
    inventory.OldWoman = -1
    inventory.Girder = -1
    inventory.BridgeKit = -1
    inventory.MailStrike = -1
    inventory.Shotgun = 10
    inventory.Uzi = -1
    inventory.Minigun = -1
    inventory.NuclearBomb = -1
    inventory.SuicideBomber = -1
    inventory.FlameThrower = -1
    inventory.GasCanister = -1
    inventory.NinjaRope = -1
    inventory.FirePunch = -1
    inventory.LowGravity = -1
    inventory.Freeze = -1
    inventory.QuickWalk = -1
    inventory.Prod = -1
    inventory.Napalm = -1
    inventory.PetrolBomb = -1
    CloseContainer(lock) -- must close the container ASAP

-- Copies this selection into each worm
   CopyContainer("Inventory.Team.Default", "Inventory.Team00")
   CopyContainer("Inventory.Team.Default", "Inventory.Team01")
end

function Payload_Deleted()
    PayloadId = GetData("Payload.Deleted.Id")
    if PayloadId == MineId then
    SetData("CommentaryPanel.Comment", "Text.TestComment")
    SendMessage("CommentaryPanel.ScriptText")
  end
end
